Package: MassArray
Type: Package
Title: Analytical Tools for MassArray Data
Version: 1.62.0
Date: 2019-03-18
Author: Reid F. Thompson <reid.thompson@gmail.com>, John M. Greally <john.greally@einstein.yu.edu>
Maintainer: Reid F. Thompson <reid.thompson@gmail.com>
Imports: graphics, grDevices, stats, utils
Depends: R (>= 2.10.0), methods
Description: This package is designed for the import, quality control, analysis, and visualization of methylation data generated using Sequenom's MassArray platform.  The tools herein contain a highly detailed amplicon prediction for optimal assay design.  Also included are quality control measures of data, such as primer dimer and bisulfite conversion efficiency estimation.  Methylation data are calculated using the same algorithms contained in the EpiTyper software package.  Additionally, automatic SNP-detection can be used to flag potentially confounded data from specific CG sites.  Visualization includes barplots of methylation data as well as UCSC Genome Browser-compatible BED tracks.  Multiple assays can be positionally combined for integrated analysis.
License: GPL (>=2)
biocViews: ImmunoOncology, DNAMethylation, SNP, MassSpectrometry,
        Genetics, DataImport, Visualization
LazyData: yes
LazyLoad: yes
git_url: https://git.bioconductor.org/packages/MassArray
git_branch: RELEASE_3_22
git_last_commit: 2c04299
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 04:50:19 UTC; biocbuild

setClass("MassArraySpectrum",
	representation(
		sample = "character",
		rxn = "character",
		strand = "character",
		peaks = "list",
		quality.conversion = "numeric",
		quality.spectra = "numeric",
		quality.primerdimer = "numeric",
		quality.contaminant = "numeric",
		quality.adducts = "numeric"
	),
	prototype(
		sample = "",
		rxn = "",
		strand = "+",
		peaks = list(),
		quality.conversion = as.numeric(0),
		quality.spectra = as.numeric(0), 
		quality.primerdimer = as.numeric(0),
		quality.contaminant = as.numeric(0),
		quality.adducts = as.numeric(0)
	)
)


setMethod("initialize",
	"MassArraySpectrum",
	function(.Object,
		sample,
		rxn = c("T", "C", "CT", "TC"),
		strand = c("+", "-"),
		peaks = list(),
		quality.conversion = NA,
		quality.spectra = NA,
		quality.primerdimer = NA,
		quality.contaminant = NA,
		quality.adducts = NA,
		...	
	) {
		.Object@sample <- as.character(sample)
		.Object@rxn <- match.arg(rxn)
		.Object@strand <- match.arg(strand)
		.Object@peaks <- peaks
		.Object@quality.conversion <- as.numeric(quality.conversion)
		.Object@quality.spectra <- as.numeric(quality.spectra)
		.Object@quality.primerdimer <- as.numeric(quality.primerdimer)
		.Object@quality.contaminant <- as.numeric(quality.contaminant)
		.Object@quality.adducts <- as.numeric(quality.adducts)
		return(.Object)
	}
)


setValidity("MassArraySpectrum",
	function(object) {
		return(TRUE)
	}
)


setMethod("$", "MassArraySpectrum",
	function (x, name) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			return(NULL)	
		}
		else {
			return(slot(x, name))	
		}
	}
)


setMethod("$<-", "MassArraySpectrum",
	function (x, name, value) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			warning("'", name, "' is not a parameter in class 'MassArraySpectrum'")
		}
		else {
			slot(x, name) <- value
		}
		return(x)
	}
)

countCGs <- function (sequence) {
	sequence <- toupper(sequence)
	return(unlist(lapply(gregexpr("(YG|CR|CG)", sequence), 
		function (CGs) {
			if (is.na(CGs[1])) {
				return(NA)	
			}
			## NO MATCHES TO "CG"
			if (CGs[1] == -1) {
				return(0)	
			}
			## ONE OR MORE MATCHES TO "CG"
			else {
				return(length(CGs))	
			}
		}
	)))
}

convControl <- function (sequence, fragmentation, multiple=FALSE) {
	sequence <- toupper(sequence)
	N <- nchar(sequence)
	fragment.positions <- unlist(lapply(fragmentation, slot, "position"))
	fragment.ends <- fragment.positions + unlist(lapply(fragmentation, slot, "length")) - 1
	fragments <- gregexpr("G[ACT]*A[CT]*C[T]*T(?=G[CTG]*A)", sequence, perl=TRUE)[[1]]
	lengths <- regexpr("G[ACT]*A[CT]*C[T]*TG[CTG]*A", substr(rep(sequence, length(fragments)), fragments, rep(N, length(fragments))))
	attr(fragments, "match.length") <- attr(lengths, "match.length")
	if (all(unlist(fragments) == -1)) {
		warning("No conversion controls found")
		return(fragmentation)	
	}
	fragments.seq <- substr(rep(sequence, length(fragments)), fragments, fragments+attr(fragments, "match.length")-1)
	fragments.tg.position <- regexpr("TG", fragments.seq) + fragments
	peaks.unique <- unique(unlist(lapply(fragmentation, slot, "MW")))
	for (i in 1:length(fragments.seq)) {
		## DO NOT INCLUDE CG-CONTAINING FRAGMENTS AS CONVERSION CONTROLS
		if (length(grep("CG", fragments.seq[i])) > 0) next
		which.fragment <- which(fragment.positions <= fragments.tg.position[i] & fragment.ends >= fragments.tg.position[i])
		## DO NOT INCLUDE FRAGMENTS THAT ARE NOT ASSAYABLE
		if (!fragmentation[[which.fragment]]$assayable) next
		## EXCLUDE FRAGMENTS LOCATED WITHIN PRIMER SEQUENCES ON EITHER END
		## (NOT TRUE CONVERSION CONTROL BECAUSE BIASED IN FAVOR OF CONVERSION)
		if (fragmentation[[which.fragment]]$primer) next
		## DO NOT INCLUDE CONTROL FRAGMENTS THAT HAVE PEAK COLLISIONS
		if (any(fragmentation[[which.fragment]]$collisions > 0)) next
		## DO NOT INCLUDE CONTROL FRAGMENTS THAT WILL INTRODUCE PEAK COLLISIONS
		if (multiple) {
			sequence.plus.control <- gsub("CA", "CR", fragmentation[[which.fragment]]$sequence)
		}
		else {
			sequence.plus.control <- sub("CA", "CR", fragmentation[[which.fragment]]$sequence)
		}
		MW <- calcMW(sequence.plus.control)
		if (any(MW[2:length(MW)] %in% peaks.unique)) next
		num.collisions <- sum(unlist(lapply(findCollisions(peaks.unique), length)) - 1 ) / 2
		peaks.unique.plus.control <- unique(c(peaks.unique, MW))
		num.collisions.plus.control <- sum(unlist(lapply(findCollisions(peaks.unique.plus.control), length)) - 1) / 2
		if (num.collisions.plus.control > num.collisions) next
		## CONVERSION CONTROL IS GOOD => UPDATE FRAGMENTATION PROFILE APPROPRIATELY
		peaks.unique <- peaks.unique.plus.control
		fragmentation[[which.fragment]]$conversion.control <- TRUE
		fragmentation[[which.fragment]]$sequence <- sequence.plus.control
		fragmentation[[which.fragment]]$MW <- as.numeric(calcMW(fragmentation[[which.fragment]]$sequence))
		fragmentation[[which.fragment]]$CpGs <- as.integer(fragmentation[[which.fragment]]$CpGs + 1)
	}
	return(fragmentation)
}

setClass("MassArrayPeak",
	representation(
		ID = "integer",
		MW.theoretical = "numeric",
		MW.actual = "numeric",
		probability = "numeric",
		SNR = "numeric",
		height = "numeric",
		sample.intensity = "numeric",
		ref.intensity = "numeric",
		sequence = "character",
		adduct = "character",
		type = "character",
		charge = "integer",
		collisions = "integer",
		components = "integer",
		missing = "logical",
		new = "logical"
	),
	prototype(
		ID = as.integer(-1),
		MW.theoretical = as.numeric(0),
		MW.actual = as.numeric(0),
		probability = as.numeric(0),
		SNR = as.numeric(0),
		height = as.numeric(0),
		sample.intensity = as.numeric(0),
		ref.intensity = as.numeric(0),
		sequence = "",
		adduct = "",
		type = "",
		charge = as.integer(0),
		collisions = as.integer(0),
		components = as.integer(0),
		missing = FALSE,
		new = FALSE
	)
)


setMethod("initialize",
	"MassArrayPeak",
	function(.Object,
		ID,
		MW.theoretical = as.numeric(0),
		MW.actual = as.numeric(0),
		probability = as.numeric(0),
		SNR = as.numeric(0),
		height = as.numeric(0),
		sample.intensity = as.numeric(0),
		ref.intensity = as.numeric(0),
		sequence = "",
		adduct = c("", "Na", "K"),
		type = c("Expected", "Modified", "Unknown", "Control"),
		charge = as.integer(1),
		collisions = as.integer(0),
		components = as.integer(0),
		missing = FALSE,
		new = FALSE,
		...	
	) {
		.Object@ID <- as.integer(ID)
		.Object@MW.theoretical <- as.numeric(MW.theoretical)
		.Object@MW.actual <- as.numeric(MW.actual)
		.Object@probability <- as.numeric(probability)
		.Object@SNR <- as.numeric(SNR)
		.Object@height <- as.numeric(height)
		.Object@sample.intensity <- as.numeric(sample.intensity)
		.Object@ref.intensity <- as.numeric(ref.intensity)
		.Object@sequence <- as.character(toupper(sequence))
		.Object@adduct <- match.arg(adduct)
		.Object@type <- match.arg(type)
		.Object@charge <- as.integer(charge)
		.Object@collisions <- as.integer(collisions)
		.Object@components <- as.integer(components)
		.Object@missing <- missing
		.Object@new <- new
		return(.Object)
	}
)


setValidity("MassArrayPeak",
	function(object) {
		return(TRUE)
	}
)


setMethod("$", "MassArrayPeak",
	function (x, name) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			return(NULL)	
		}
		else {
			return(slot(x, name))	
		}
	}
)


setMethod("$<-", "MassArrayPeak",
	function (x, name, value) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			warning("'", name, "' is not a parameter in class 'MassArrayPeak'")
		}
		else {
			slot(x, name) <- value
		}
		return(x)
	}
)

findCollisions <- function (peaks, resolution=0.5) {
	collision <- function (MW, peaks, resolution) {
		peaks <- which(abs(peaks - MW) < resolution)
		if (length(peaks) <= 1) {
			return(0)	
		}
		else {
			return(peaks)
		}
	}
	return(lapply(peaks, collision, peaks, resolution))
}

numCollisions <- function (peaks, resolution=0.5) {
	collision <- function (MW, peaks, resolution) {
		peaks <- which(abs(peaks - MW) < resolution)
		return(length(peaks) - 1)
	}	
	return(unlist(lapply(peaks, collision, peaks, resolution)))
}

findPeaks <- function (MW, peaks, resolution=1) {
	peaks.found <- c()
	if ((length(MW) < 1) | (length(peaks) < 1)) return()
	for (i in 1:length(MW)) {
		peak.i <- which(abs(peaks - MW[i]) < resolution)
		if (length(peak.i) < 1) peak.i <- NA
		peaks.found <- c(peaks.found, peak.i)
	}
	return(peaks.found)
}

findFragments <- function (MW, fragments, resolution=1) {
	if (length(MW) < 1) return()
	MWs <- lapply(fragments, slot, "MW")
	MW.matches <- rep(NA, length(unlist(MWs)))
	if (length(MW.matches) < 1) return()
	MW.matches[findPeaks(MW, unlist(MWs), resolution)] <- 1
	MW.matches <- relist(!is.na(MW.matches), MWs)
	fragments.found <- which(unlist(lapply(MW.matches, any)))
	if (length(fragments.found) < 1) return()
	return(fragments[fragments.found])
}

rnaDigest <- function (sequence, type=c("T", "C")) {
	sequence <- toupper(sequence)
	sequence.length <- nchar(sequence)
	type <- match.arg(type)
	switch(type,
		"T" = fragments <- gregexpr("[ACGNXYR.]*T", sequence)[[1]],
		"C" = fragments <- gregexpr("C[ATGNXYR.]*", sequence)[[1]]
	)
	num.fragments <- length(fragments)
	positions <- as.integer(fragments)
	fragments <- substr(rep(sequence, num.fragments), as.integer(fragments), as.integer(fragments) + attr(fragments, "match.length") - 1)
	N <- nchar(paste(fragments, sep="", collapse=""))
	if (N < sequence.length) {
		if (type == "T") {
			fragments <- c(fragments, substr(sequence, N + 1, sequence.length))
			positions <- c(positions, N + 1)
		}
		else {
			fragments <- c(substr(sequence, 1, sequence.length - N), fragments)
			positions <- c(1, positions)
		}
		num.fragments <- num.fragments + 1
	}
	digests <- c()
	for (i in 1:num.fragments) {
		digests <- c(digests,
			new("MassArrayFragment", ID=i, sequence=fragments[i], position=positions[i], type=type, bisulfite.converted=TRUE)
		)
	}
	return(digests)
}

evaluateSNPs <- function(x, verbose=TRUE, plot=TRUE) {

	## A FEW IMPORTANT NOTES:
	## 1) calculations are SUPER-SLOW RIGHT NOW . . . limiting step is the N-scanning SNP detection . . .
	##		current implementation loops through N-scan as many times as there are novel sequences!
	##		better implementation will be to do N-scanning once and through each N-scan test which sequences from set match!!!
	##		will likely see dramatic performance improvement! . . . just make sure output for new version same as old!
	## 2) does not factor in conversion controls with SNP new peak analysis . . . determine if fragment could be conversion
	##		control AND if SNP identity would be like the converted sequence => if so, then IGNORE as a SNP => will consider
	##		when analyze for conversion controls

	if ((class(x) != "MassArrayData") | !validObject(x)) {
		stop("not a valid object of 'MassArrayData'")
	}
	N <- length(x$samples)
	if (N < 1) stop("no samples to analyze")
	sequence.tagged <- revComplement(paste(x$fwd.tag, bisConvert(x$sequence), x$rev.tag, sep=""))
	N.seq <- nchar(sequence.tagged)
	rxns <- unique(unlist(lapply(x$samples, slot, "rxn")))
	SNP.list <- c()
	if (plot) {
		plot(0, type="n", 
			xlim=c(1, 1000), 
			ylim=c(1, 5), xlab="Nucleotide position (bp)", ylab="",
			main="inSilico SNP Prediction", axes=FALSE)
		usr <- par("usr")
		scale <- function (x, min1, max1, min2=usr[1], max2=usr[2]) {
			return(min2 + (x - min1) * (max2 - min2) / (max1 - min1))
		}
	}
	for (rxn in rxns) {
		which.rxn <- grep(rxn, unlist(lapply(x$samples, slot, "rxn")))
		if (length(which.rxn) < 1) next
		switch(rxn,
			"T" = fragments <- x$fragments.T,
			"C" = fragments <- x$fragments.C
		)
		fragment.starts <- unlist(lapply(fragments, slot, "position"))
		fragment.ends <- fragment.starts + unlist(lapply(fragments, slot, "length")) - 1
		fragments.total <- length(fragments)
		## IDENTIFY FRAGMENTS THAT HAVE CGs AND ARE NOT CONVERSION CONTROLS
		CpG.positions <- gregexpr("[CY][GR]", paste(x$fwd.tag, x$sequence, x$rev.tag, sep=""))[[1]]
		CpG.fragments <- unlist(lapply(CpG.positions, 
			function(x) {
				positions <- unlist(lapply(fragments, slot, "position"))
				lengths <- unlist(lapply(fragments, slot, "length"))
				return(which(x >= positions & x < positions + lengths))
			}
		))
		if (plot) {
			## DISPLAY FRAGMENTATION PROFILES GRAPHICALLY
			fragment.margin <- 4.5-2*(which(rxn == rxns) - 1)
			sequence.start <- scale(nchar(x$fwd.tag), 1, N.seq)
			sequence.end <- scale(N.seq - nchar(x$rev.tag) + 1, 1, N.seq)
			## PLOT SEQUENCE TAGS AND LABELS
			rect(scale(1, 1, N.seq), 
				scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
				sequence.start, 
				scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
				col="yellow", border="yellow"
			)
			rect(sequence.end, 
				scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
				scale(N.seq, 1, N.seq), 
				scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
				col="yellow", border="yellow"
			)
			segments(c(sequence.start, sequence.end), 
				scale(fragment.margin - 0.325, 1, 5, usr[3], usr[4]), 
				c(sequence.start, sequence.end), 
				scale(fragment.margin + 0.225, 1, 5, usr[3], usr[4]), 
				col="black", lwd=1
			)
			text(c(sequence.start, sequence.end), 
				scale(fragment.margin + 0.325, 1, 5, usr[3], usr[4]), 
				labels=paste(c(paste(rxn, ": 1", sep=""), (N.seq - nchar(x$fwd.tag) - nchar(x$rev.tag))), "bp"), 
				cex=0.75
			)
#			if (strand == "-") {
#				CpG.positions <- rev(N.seq - (CpG.positions + 1) + 1)
#			}
			## PLOT EACH FRAGMENT, ONE AT A TIME
			for (fragment.i in fragments) {
#				if (strand == "-") {
#					fragment.i$position <- as.integer(N.seq - (fragment.i$position + fragment.i$length - 1) + 1)
#				}
				CpGs.i <- which(CpG.positions >= fragment.i$position & CpG.positions < fragment.i$position + fragment.i$length)
				## DISPLAY FRAGMENTATION PROFILE
				segment.start <- scale(fragment.i$position, 1, N.seq)
				segment.end <- scale(fragment.i$position + fragment.i$length - 0.01, 1, N.seq)
				## HIGHLIGHT REQUIRED FRAGMENTS (USER-SPECIFIED)
				if (fragment.i$required) {
					rect(segment.start,
						scale(fragment.margin - 0.325, 1, 5, usr[3], usr[4]), 
						segment.end,
						scale(fragment.margin + 0.2, 1, 5, usr[3], usr[4]),
						col="#FFEEFF", border="#FFEEFF"
					)	
				}
				## HIGHLIGHT FRAGMENTS THAT ARE LOCATED WITHIN PRIMERS (DO NOT REPEAT HIGHLIGHTING OF TAG SEQUENCES)
				if (fragment.i$primer & fragment.i$position < N.seq - nchar(x$rev.tag) + 1 & fragment.i$position + fragment.i$length - 1 > nchar(x$fwd.tag)) {
					rect(max(segment.start, scale(nchar(x$fwd.tag) + 1, 1, N.seq)), 
						scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
						min(segment.end, scale(N.seq - nchar(x$rev.tag), 1, N.seq)), 
						scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
						col="#FFFFCC", border="#FFFFCC"
					)
				}
				## IS THIS FRAGMENT ASSAYABLE (I.E. BETWEEN THE LOWER/UPPER MW THRESHOLDS)?
				if (fragment.i$assayable) {
					## SELECT APPROPRIATE COLORS FOR EACH FRAGMENT
					if (fragment.i$conversion.control) {
						color.i <- "green"
					}
					else if (fragment.i$CpGs > 0) {
						color.i <- "blue"	
					}
					else {
						color.i <- "black"
					}
					if (sum(fragment.i$collisions) > 0) {
						color.i <- "red" #FF6600
					}
					## PLOT FRAGMENT DELIMITERS
					segments(segment.start, 
						scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
						segment.start, 
						scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
						col=color.i, lwd=0.5
					)
					segments(segment.end, 
						scale(fragment.margin - 0.075, 1, 5, usr[3], usr[4]), 
						segment.end, 
						scale(fragment.margin + 0.075, 1, 5, usr[3], usr[4]), 
						col=color.i, lwd=0.5
					)
				}
				## ELSE... FRAGMENT IS NOT ASSAYABLE
				else {
					color.i <- "gray"
				}
				## FINISH PLOTTING FRAGMENTATION (HORIZONTAL SEGMENTS)
				segments(segment.start, 
					scale(fragment.margin, 1, 5, usr[3], usr[4]), 
					segment.end, 
					scale(fragment.margin, 1, 5, usr[3], usr[4]), 
					col=color.i, lwd=0.5
				)
				## PLOT CGs ALONG FRAGMENTATION PROFILE
				if ((fragment.i$CpGs > 0) & !fragment.i$conversion.control) {
					CpG.positions.i <- scale(CpG.positions[CpGs.i], 1, N.seq)
					points(CpG.positions.i, 
						rep(scale(fragment.margin, 1, 5, usr[3], usr[4]), length(CpGs.i)), 
						pch=19, col=color.i, cex=0.5
					)
					text(CpG.positions.i, 
						rep(scale(fragment.margin + 0.225, 1, 5, usr[3], usr[4]), length(CpGs.i)), 
						labels=c(CpGs.i[1], rep(".", length(CpGs.i) - 1)), 
						cex=0.4, col=color.i
					)
				}
			}
		}
		
		new.peaks <- unlist(lapply(x$samples[which.rxn], slot, "peaks"), recursive=FALSE)[which(unlist(lapply(unlist(lapply(x$samples[which.rxn], slot, "peaks"), recursive=FALSE), slot, "new")))]
		if (verbose) cat("Examining ", rxn, " reaction for SNPs: ", length(which.rxn), " samples, ", length(new.peaks), " 'NEW' peaks ... ", sep="")
		new.peaks.sequence <- unique(unlist(lapply(new.peaks, slot, "sequence")))
		## IGNORE SEQUENCES THAT ARE NOT WITHIN THE ASSAYABLE RANGE
		new.peaks.sequence <- new.peaks.sequence[unlist(lapply(new.peaks.sequence, 
			function(sequence) {
				return(lapply(lapply(calcMW(sequence), isAssayable), any))
			}
		))]
		## SEARCH FOR POTENTIAL SNPs IN SEQUENCE, ONE AT A TIME (VERY SLOW STEP) WITH AS FEW AS POSSIBLE
		new.peak.SNPs <- lapply(new.peaks.sequence, identifySNPs, sequence.tagged, rxn)
		print("done")
		if (verbose) cat("FINISHED (", length(new.peak.SNPs), " potential SNPs identified)\n", sep="")
		## MODIFY SNP POSITIONS TO CORRESPOND TO PROPER FWD-STRANDED SEQUENCE
		new.peak.SNPs <- lapply(new.peak.SNPs,
			function(SNPs) {
				if ((length(SNPs)) < 1) return()
				for (i in 1:length(SNPs)) {
					SNPs[[i]]$position <- nchar(sequence.tagged) - SNPs[[i]]$position + 1
					SNPs[[i]]$fragment <- which(fragment.starts <= SNPs[[i]]$position & fragment.ends >= SNPs[[i]]$position)
				}
				return(SNPs)
			}
		)
		best.SNPs <- c()
		## ALL POTENTIAL SNPs HAVE BEEN IDENTIFIED, NOW ITS TIME TO COMPARE ON A SAMPLE-BY-SAMPLE BASIS
		for (i in 1:length(which.rxn)) {
			sample <- x$samples[[which.rxn[i]]]
			## CALCULATE AVERAGE PER-FRAGMENT SNR
			SNR.total <- sum(unlist(lapply(sample$peaks, slot, "SNR")), na.rm=TRUE)
			SNR.avg <- SNR.total / fragments.total
			## IDENTIFY MISSING EXPECTED PEAKS
			missing.peaks <- sample$peaks[which(unlist(lapply(sample$peaks, slot, "missing")) & (unlist(lapply(sample$peaks, slot, "type")) == "Expected"))]
			## MAP EACH MISSING PEAK TO ITS CORRESPONDING EXPECTED FRAGMENT
			missing.fragments <- unlist(lapply(unlist(lapply(unlist(lapply(missing.peaks, slot, "MW.theoretical")), findFragments, fragments)), slot, "ID"))
			## GET NEW PEAKS (AND THEIR PREDICTED SEQUENCES) ON A PER-SAMPLE BASIS
			new.sample.peaks <- sample$peaks[which(unlist(lapply(sample$peaks, slot, "new")))]
			new.sample.sequences <- unlist(lapply(unique(unlist(lapply(new.sample.peaks, slot, "sequence"))), expandSequence))
			## FIND SUBSET OF SNPs THAT MATCH NEW PEAK SEQUENCES FOR THIS SAMPLE
			sample.SNPs <- lapply(new.peak.SNPs,
				function(SNPs) {
					if (length(SNPs) < 1) return()
					if (length(SNPs[[1]]$sequence) < 1) return()
					if (length(new.sample.peaks) < 1) return()
					matched.peak <- which(unlist(lapply(new.sample.peaks, 
						function(peak) {
							return(SNPs[[1]]$sequence %in% unlist(lapply(peak$sequence, expandSequence)))
						}
					)))
#					matched.sequence <- match(SNPs[[1]]$sequence, new.sample.sequences)
					if (length(matched.peak) < 1) return()
					SNR <- max(unlist(lapply(new.sample.peaks[matched.peak], slot, "SNR")), na.rm=TRUE)
					if (is.na(SNR)) return()
					if (SNR <= 0) return()
					for (i in 1:length(SNPs)) {
						## STORE SNR DATA (NOTE THAT THIS ASSUMES THAT A NEW PEAK ARISES FROM ONE SIGNAL, NOT MULTIPLE)
						SNPs[[i]]$SNR <- SNR
						SNPs[[i]]$SNP.present <- min(1, max(0, SNR / SNR.avg))
						if (SNPs[[i]]$fragment %in% missing.fragments) {
							SNPs[[i]]$WT.absent <- 1
						}
						else {
							matched.peaks <- findPeaks(fragments[[SNPs[[i]]$fragment]]$MW, unlist(lapply(sample$peaks, slot, "MW.theoretical")))
#							matched.peaks <- unique(c(matched.peaks, findPeaks(fragments[[SNPs[[i]]$fragment]]$MW, unlist(lapply(sample$peaks, slot, "MW.actual")))))
							matched.peaks <- sample$peaks[matched.peaks[!is.na(matched.peaks)]]
							if (length(matched.peaks) < 1) {
								SNPs[[i]]$WT.absent <- 0
								next
							}
							count.estimate <- sum(unlist(lapply(matched.peaks,
								function(peak) {
									return(min(1, peak$components) - peak$SNR / SNR.avg)
								}
							)), na.rm=TRUE)
							if (is.na(count.estimate)) {
								SNPs[[i]]$WT.absent <- 0
								next
							}
							if (count.estimate > 0) {
								SNPs[[i]]$WT.absent <- 1
							}
							else {
								components <- sum(pmax(unlist(lapply(matched.peaks, slot, "components")), 1), na.rm=TRUE)
								SNR.sum <- sum(unlist(lapply(matched.peaks, slot, "SNR")), na.rm=TRUE)
								SNPs[[i]]$WT.absent <- min(1, max(0, components - SNR.sum / SNR.avg))
							}
						}
					}
					## ALSO MAKE SURE TO RETURN SNR DATA FOR THIS SAMPLE
					return(SNPs)
				}
			)
			## GET LIST OF FRAGMENTS CORRESPONDING TO SNPs
			sample.SNP.fragments <- unlist(lapply(unlist(sample.SNPs, recursive=FALSE), 
				function(SNP) {
					return(SNP$fragment)
				}
			))
			sample.SNP.fragments <- duplicated(sample.SNP.fragments)
			## CALCULATE APPROPRIATE SAMPLE POSITION INFORMATION FOR PLOTTING
			sample.position <- fragment.margin - 0.5 - (3/length(rxns))*(i - 1)/length(which.rxn)
			## PLOT MISSING PEAKS
			if (plot) {
				text(scale(1, 1, N.seq),
					scale(sample.position, 1, 5, usr[3], usr[4]),
					labels=sample$sample, cex=0.25, col="black", pos=4, offset=0.5, srt=90
				)
			}
			for (SNP in unlist(sample.SNPs, recursive=FALSE)) {
				if (!fragments[[SNP$fragment]]$assayable) {
					next
				}
				## MAP SNP POSITION TO THE CENTER OF ITS CONTAINING FRAGMENT
				SNP.position <- fragments[[SNP$fragment]]$position + fragments[[SNP$fragment]]$length/2
				if ((SNP$SNP.present == 1) & (SNP$WT.absent == 1)) {
					color.SNP <- "black"	
					cex.SNP <- 0.75
				}
				else if ((SNP$SNP.present == 1) | (SNP$WT.absent == 1)) {
					color.SNP <- "gray"	
					cex.SNP <- 0.25
				}
				else {
					next
				}
				SNP.map <- match(SNP$sequence, unlist(lapply(best.SNPs, 
						function(SNP) {
							return(SNP$sequence)
						}
					), recursive=FALSE)
				) 
				SNP.map <- SNP.map[which(!is.na(SNP.map))]
				if (length(SNP.map) > 0) {
					best.SNPs[[SNP.map]]$SNP <- c(best.SNPs[[SNP.map]]$SNP, paste(SNP$position, ":", SNP$base, sep=""))
					best.SNPs[[SNP.map]]$SNR <- c(best.SNPs[[SNP.map]]$SNR, SNP$SNR)
					best.SNPs[[SNP.map]]$fragment <- c(best.SNPs[[SNP.map]]$fragment, SNP$fragment)
					best.SNPs[[SNP.map]]$SNP.quality <- c(best.SNPs[[SNP.map]]$SNP.quality, (SNP$SNP.present + SNP$WT.absent))
					best.SNPs[[SNP.map]]$samples <- c(best.SNPs[[SNP.map]]$samples, sample$sample)
					best.SNPs[[SNP.map]]$count <- best.SNPs[[SNP.map]]$count + 1
				}
				else {
					best.SNPs <- c(best.SNPs, list(list(sequence=SNP$sequence, fragment=SNP$fragment, SNR=SNP$SNR, SNP=paste(SNP$position, ":", SNP$base, sep=""), SNP.quality=(SNP$SNP.present + SNP$WT.absent), samples=sample$sample, count=1)))
				}
				if (SNP$base %in% c("A", "T", "C", "G")) {
					pch.SNP <- 2
				}
				else if (SNP$base == "") {
					pch.SNP <- "O"
					cex.SNP <- cex.SNP + 0.25
				}					
				else {
					pch.SNP <- 20
				}	
				if (SNP$fragment %in% missing.fragments) {
					if (plot) {
						text(
							scale(SNP.position, 1, N.seq),
							scale(sample.position, 1, 5, usr[3], usr[4]),
							labels="X", col="red", cex=1
						)
					}
				}
				if (plot) {
					points(scale(SNP.position, 1, N.seq),
						scale(sample.position, 1, 5, usr[3], usr[4]),
						pch=pch.SNP, cex=cex.SNP, col=color.SNP
					)	
				}
				if (SNP$fragment %in% sample.SNP.fragments) {
					if (plot) {
						points(scale(SNP.position, 1, N.seq),
							scale(sample.position, 1, 5, usr[3], usr[4]),
							pch=20, cex=0.5, col="yellow"
						)	
					}
				}
			}
			SNP.list <- c(SNP.list, list(list(sample=sample$sample, SNPs=sample.SNPs)))
		}
	}
	return(best.SNPs)
#	return(SNP.list)
}

sum.MassArraySpectrum <- function (x, ..., trim=0, na.rm=TRUE) useMethod("sum")

sum.MassArraySpectrum <- function (x, ..., trim=0, na.rm=TRUE) {
	spectra <- c(x, ...)
	samples <- unlist(lapply(spectra, slot, "sample"))
	rxn <- unique(unlist(lapply(spectra, slot, "rxn")))
	if (length(rxn) > 1) {
		warning("Spectral data contains both T&C reactions")
		rxn <- "TC"
	}
	strand <- unlist(lapply(spectra, slot, "strand"))
#	quality.conversion <- unlist(lapply(lapply(spectra, slot, "quality.conversion"), mean, trim=trim, na.rm=na.rm))
	quality.conversion <- unlist(lapply(spectra, slot, "quality.conversion"))
	quality.spectra <- mean(unlist(lapply(spectra, slot, "quality.spectra")), trim=trim, na.rm=na.rm)
	peaks <- list()
	for (i in spectra) {
		peaks.i <- i$peaks
		MW <- unlist(lapply(peaks, "[", "MW"))
		## BECAUSE USING THEORETICAL MW VALUES, PEAKS SHOULD BE EXACT MATCHES => CAN EMPLOY match() FUNCTION INSTEAD OF findPeaks()
		matched.peaks <- match(unlist(lapply(peaks.i, slot, "MW.theoretical")), MW)
		defined.peaks <- which(!is.na(matched.peaks))
		for (j in defined.peaks) {
			peaks[[matched.peaks[j]]]$peaks <- c(peaks[[matched.peaks[j]]]$peaks, peaks.i[j])
		}
		additional.peaks <- which(is.na(matched.peaks))
		for (j in additional.peaks) {
			peaks <- c(peaks, list(list(MW=peaks.i[[j]]$MW.theoretical, peaks=peaks.i[j])))
		}
	}
	MW <- unlist(lapply(peaks, "[", "MW"))
	peaks <- lapply(peaks, "[", "peaks")
	for (i in 1:length(peaks)) {
		if (peaks[[i]]$peaks[[1]]$adduct == "") adduct <- NULL
		else adduct <- peaks[[i]]$peaks[[1]]$adduct
		MW.actual <- mean(unlist(lapply(peaks[[i]]$peaks, slot, "MW.actual")), trim=trim, na.rm=na.rm)
		if (is.na(MW.actual)) MW.actual <- MW[i]
		peaks[[i]] <- new("MassArrayPeak", ID=as.integer(i),
						MW.theoretical=MW[i],
						MW.actual=MW.actual,
						probability=mean(unlist(lapply(peaks[[i]]$peaks, slot, "probability")), trim=trim, na.rm=na.rm),
						SNR=sum(unlist(lapply(peaks[[i]]$peaks, slot, "SNR")), na.rm=na.rm),
						height=sum(unlist(lapply(peaks[[i]]$peaks, slot, "height")), na.rm=na.rm),
						intensity=sum(unlist(lapply(peaks[[i]]$peaks, slot, "intensity")), na.rm=na.rm),
						adduct=adduct, 
						type=peaks[[i]]$peaks[[1]]$type, 
						missing=all(unlist(lapply(peaks[[i]]$peaks, slot, "missing"))), 
						new=any(unlist(lapply(peaks[[i]]$peaks, slot, "new"))),
						collisions=sum(unlist(lapply(peaks[[i]]$peaks, slot, "collisions")), na.rm=na.rm),
						components=ceiling(mean(unlist(lapply(peaks[[i]]$peaks, slot, "components")), trim=trim, na.rm=na.rm))
					)
	}
	if (length(samples) <= 1) sample.name <- samples[1]
	else if (length(unique(samples)) <= 1) sample.name <- unique(samples)
	else sample.name <- paste("mean(", samples[1], " ... ", samples[length(samples)], ")", sep="")
	return(new("MassArraySpectrum", sample=sample.name , rxn=paste(rxn, collapse=""), strand=strand[1], peaks=peaks, quality.conversion=quality.conversion, quality.spectra=quality.spectra))
}

estimatePrimerDimer <- function (fragments, peaks, method=c("ratio", "mann-whitney")) {
	## FIRST IDENTIFY FRAGMENTS OVERLAPPING (OR NOT) PRIMERS
	is.primer <- unlist(lapply(fragments, slot, "primer"))
	fragments.primer <- which(is.primer)
	fragments.noprimer <- which(!is.primer)
	## THEN EXTRACT THE MOLECULAR WEIGHTS (ONLY CONSIDER MWs THAT ARE ASSAYABLE) . . .
	MWs.primer <- unlist(lapply(fragments[fragments.primer], slot, "MW"))
	MWs.noprimer <- unlist(lapply(fragments[fragments.noprimer], slot, "MW"))
	MWs.primer <- MWs.primer[isAssayable(MWs.primer)]
	MWs.noprimer <- MWs.noprimer[isAssayable(MWs.noprimer)]
	## . . . AND MATCH THE APPROPRIATE PEAKS
	peaks.primer <- findPeaks(MWs.primer, unlist(lapply(peaks, slot, "MW.theoretical")))
	peaks.noprimer <- findPeaks(MWs.noprimer, unlist(lapply(peaks, slot, "MW.theoretical")))
	## DO NOT CONSIDER MISSING OR OTHERWISE UNMATCHED PEAKS
	peaks.primer <- peaks.primer[which(!is.na(peaks.primer))]
	peaks.noprimer <- peaks.noprimer[which(!is.na(peaks.noprimer))]
	## CALCULATE SCALED SNR FOR EACH PEAK
	data.primer <- unlist(lapply(peaks[peaks.primer], slot, "SNR")) / unlist(lapply(peaks[peaks.primer], slot, "ref.intensity"))
	data.noprimer <- unlist(lapply(peaks[peaks.noprimer], slot, "SNR")) / unlist(lapply(peaks[peaks.noprimer], slot, "ref.intensity"))
#	SNR.p <- mean(unlist(lapply(peaks[peaks.primer], slot, "SNR")),na.rm=TRUE)
#	SNR.np <- mean(unlist(lapply(peaks[peaks.noprimer], slot, "SNR")),na.rm=TRUE)
#	R.p <- mean(unlist(lapply(peaks[peaks.primer], slot, "ref.intensity")),na.rm=TRUE)
#	R.np <- mean(unlist(lapply(peaks[peaks.noprimer], slot, "ref.intensity")),na.rm=TRUE)

	## IF INSUFFICIENT DATA TO CALCULATE PRIMER DIMER
	if ((length(data.primer) < 1) | (length(data.noprimer) < 1)) return(NA)

	method <- match.arg(method)
	## SIMPLE RATIO OF OVERALL PEAK HEIGHTS
	if (method == "ratio") {
		return(pmax(0, data.primer / median(data.noprimer, na.rm=TRUE) - 1))
	}
	## MANN-WHITNEY U-TEST:  DO POPULATIONS OF PEAKS FROM PRIMER AND NON-PRIMER HAVE DIFFERENT MEANS?
	else if (method == "mann-whitney") {
		test <- wilcox.test(data.primer, data.noprimer, paired=FALSE, conf.int=TRUE, exact=FALSE)
		return(test$p.value)
	}
}

calcPercentAdduct <- function(peaks) {
	sequences <- lapply(peaks, slot, "sequence")
	## IDENTIFY ADDUCTS AND THEIR MATCHING REFERENCE PEAKS
	adduct.peaks <- which((unlist(lapply(peaks, slot, "adduct")) != "") & (lapply(sequences, length) == 1))
	adduct.peaks <- unique(unlist(lapply(peaks[adduct.peaks], slot, "sequence")))
	if (length(adduct.peaks) < 1) { return(numeric(0)) }
	
	## IDENTIFY MATCHING REFERENCE PEAKS
	adduct.ratios <- unlist(lapply(adduct.peaks,
		function (adduct) {
			## WHICH PEAKS MATCH THE SEQUENCE FOR THIS ADDUCT PEAK?
			matched.by.sequence <- which(unlist(lapply(lapply(sequences, "%in%", adduct), any)))
			## IDENTIFY ADDUCTS
			adducts <- matched.by.sequence[which(unlist(lapply(peaks[matched.by.sequence], slot, "adduct")) != "")]
			adducts <- sum(unlist(lapply(peaks[adducts], slot, "SNR")))
			## FILTER OUT ADDUCT, DOUBLY CHARGED, ABORTIVE CYCLING, AND OTHER MODIFIED PEAKS
			non.adducts <- matched.by.sequence[which(unlist(lapply(peaks[matched.by.sequence], slot, "type")) != "Modified")]
			non.adducts <- sum(unlist(lapply(peaks[non.adducts], slot, "SNR")))
			## CALCULATE RATIO OF ADDUCT PEAK HEIGHTS TO THEIR REFERENCES
			return(adducts / (adducts + non.adducts))
		}
	))

	return(median(adduct.ratios))
}


calcPercentConversion <- function(fragments, peaks) {
	controls <- which(unlist(lapply(fragments, slot, "conversion.control")))
	controls.meth <- c()
	for (i in controls) {
		frags.i <- fragments[[i]]$"MW"
		peaks.i <- findPeaks(frags.i, unlist(lapply(peaks, slot, "MW.actual")))
		peaks.i.theory <- findPeaks(frags.i, unlist(lapply(peaks, slot, "MW.theoretical")))
		peaks.i[which(is.na(peaks.i))] <- peaks.i.theory[which(is.na(peaks.i))]
		SNRs.i <- unlist(lapply(peaks[peaks.i], slot, "SNR"))
## EXTRACT SIGNAL-TO-NOISE RATIO (SNR) INFORMATION FOR EACH PEAK
		SNRs.i <- peaks.i
		if (any(!is.na(peaks.i))) {
			SNRs.i[which(!is.na(peaks.i))] <- unlist(lapply(peaks[peaks.i[which(!is.na(peaks.i))]], slot, "SNR"))
		}
## MAP ALL COLLIDING FRAGMENTS TO LIST OF MOLECULAR WEIGHTS
		collisions.i <- lapply(frags.i, 
							   function(x) {
							   temp <- findFragments(x, fragments)
							   IDs <- unlist(lapply(temp, slot, "ID"))
							   return(unique(IDs))
							   }
							   )
## IDENTIFY WHICH FRAGMENTS ARE NON-CONTRIBUTORY TO METHYLATION STATE (E.G. NON-CG-CONTAINING FRAGMENTS)
		non.cg.fragments <- setdiff(unlist(collisions.i), i)		
		controls.meth <- c(controls.meth, calcMeth(SNRs.i, fragments=collisions.i, non.cg.fragments=non.cg.fragments))
	}
	return(as.numeric(controls.meth))
}


calcMeth <- function(SNR.list, fragments=rep(1, length(SNR.list)), non.cg.fragments=numeric(0), method=c("weighted", "proportion"), prune.non.cg.peaks=TRUE, na.rm=FALSE) {
## HANDLE INPUTS TO ENSURE IMPORTANT ASSUMPTIONS (E.G. SNR.LIST REPRESENTS NUMERICAL INPUT)
	method <- match.arg(method)
	SNR.list <- as.numeric(SNR.list)
	num.SNRs <- length(SNR.list)
	non.cg.fragments <- unique(non.cg.fragments)
## REMOVE NAs FROM INPUT SNR LIST
	if (any(is.na(SNR.list))) {
		if (!na.rm) return(NA)
		if (all(is.na(SNR.list))) return(NA)
		SNR.list[which(is.na(SNR.list))] <- 0
	}
	if ((num.SNRs > length(fragments)) & (any(SNR.list == 0))) {
		SNR.list <- SNR.list[which(SNR.list != 0)]
		num.SNRs <- length(SNR.list)
	}
	if (num.SNRs != length(fragments)) {
		warning("lengths of input SNR.list and fragments do not match")
		return(NA)
	}
	if (num.SNRs < 1) {
		warning("SNR.list input must contain at least one value")
		return(NA)
	}
## CALCULATE AVERAGE SNR PER CONTRIBUTING FRAGMENT
	num.fragments <- length(unique(unlist(fragments)))
	SNR.avg <- sum(SNR.list) / num.fragments
## REMOVE NON-CG PEAKS FROM INPUT DATASET VIA ASSUMPTION OF EQUIVALENT AVERAGE PEAK HEIGHTS
	if (prune.non.cg.peaks) {
		for (i in non.cg.fragments) {
			temp <- which(unlist(lapply(lapply(fragments, "%in%", i), any)))
			SNR.list[temp] <- max(SNR.list[temp]-SNR.avg, 0)
		}
		fragments <- lapply(fragments, setdiff, non.cg.fragments)
		num.fragments <- length(unique(unlist(fragments)))
		non.cg.fragments <- numeric(0)
	}
	cgs <- unique(unlist(fragments))
	if (num.fragments < 1) {
		return(NA)	
	}
## SETUP SYSTEM OF LINEAR EQUATIONS
	N <- num.SNRs * num.fragments
	linear.eqs <- matrix(0, nr=0, nc=N)
	solutions <- numeric(0)
## RULE ONE: TOTAL PROPORTIONAL CONTRIBUTIONS FROM EACH CG MUST TOTAL TO 1
	temp <- matrix(0, nr=num.SNRs, nc=N)
	for (i in 1:num.SNRs) {
		cgs.i <- fragments[[i]]	
		index.i <- match(cgs.i, cgs)
		temp[i, (index.i - 1)*num.SNRs + i] <- 1
	}
	linear.eqs <- rbind(linear.eqs, temp)
	solutions <- c(solutions, rep(1, num.SNRs))
## RULE TWO: CGs THAT DO NOT CONTRIBUTE TO A PEAK MUST BE ASSIGNED A COEFFICIENT OF ZERO FOR THAT PEAK
	for (i in 1:num.SNRs) {
		cgs.i <- fragments[[i]]
		missing <- which(!(cgs %in% cgs.i))
		num.missing <- length(missing)
		if (num.missing < 1) next
		temp <- matrix(0, nr=num.missing, nc=N)
		for (j in 1:num.missing) {
			temp[j, (missing[j] - 1)*num.SNRs + i] <- 1
		}
		linear.eqs <- rbind(linear.eqs, temp)
		solutions <- c(solutions, rep(0, num.missing))
	}
## RULE THREE: METHYLATION STATE IS EQUIVALENT FOR TWO (OR MORE) CGs THAT HAVE IDENTICAL PEAK DISTRIBUTIONS
	cg.list <- list()
	for (i in 1:num.fragments) {
		cg.list[[i]] <- which(unlist(lapply(lapply(fragments, match, cgs[i]), any)))
	}
	for (i in which(duplicated(cg.list))) {
		dup.cgs <- which(unlist(lapply(cg.list, identical, cg.list[[i]])))
		dup.cgs <- setdiff(dup.cgs, i)[1]
		temp <- matrix(0, nr=num.SNRs, nc=N)
		for (j in 1:num.SNRs) {
			temp[j, (i - 1)*num.SNRs + j] <- -1
			temp[j, (dup.cgs - 1)*num.SNRs + j] <- 1
		}
		solutions <- c(solutions, rep(0, num.SNRs))
		linear.eqs <- rbind(linear.eqs, temp)
	}
	
## SOLVE SYSTEM OF LINEAR EQUATIONS
	qr.coefs <- qr.coef(qr(linear.eqs), solutions)
## IF SYSTEM OF EQUATIONS IS INCOMPLETE, DETERMINE IDEAL VALUES FOR REMAINING COEFFICIENTS BY RANDOM-VALUE OPTIMIZATION
	if (any(is.na(qr.coefs))) {
		warning("Ambiguous methylation data, calculating optimal values (please be patient as this may take considerable time)")
		na.coefs <- which(is.na(qr.coefs))
		temp <- matrix(0, nr=length(na.coefs), nc=N)
		for (i in 1:length(na.coefs)) {
			temp[i, na.coefs[i]] <- 1
		}
		linear.eqs <- rbind(linear.eqs, temp)
		qr.eqs <- qr(linear.eqs)
		
################################################################################################
## DEFINE OPTIMIZATION FUNCTION FOR SITUATIONS WHERE SYSTEM OF LINEAR EQUATIONS IS INSUFFICIENT
################################################################################################
##
		optimizeCoefficients <- function(coefs=rep(0.5, length(na.coefs)), range=(-500000:500000)/1000000, score.best=Inf, tol=1e-4) {
# DEFINE OPTIMIZATION FUNCTION
			opt.eval <- matrix(0, nr=num.fragments, nc=N)
			for (i in 1:num.fragments) {
				opt.eval[i, (i-1)*num.SNRs + 1:num.SNRs] <- SNR.list
			}
			results <- matrix(NA, nr=length(coefs)+1, nc=length(coefs))
			scores <- rep(NA, length(coefs)+1)
			for (i in 1:(length(coefs)+1)) {
				repeat {
					count <- 100
# IDENTIFY A SET OF COEFFICIENTS THAT SATISFY CRITERIA AS BELOW
					repeat {
						repeat {
# GENERATE RANDOM COEFFICIENTS BY RANDOM-WALK ALGORITHM
							rand <- coefs + sample(range*count/100, size=length(coefs))
# ENSURE THAT STAY WITHIN BOUNDARY LIMITS FOR A COEFFICIENT (0<=X<=1)
							if (all(rand >= 0 & rand <= 1)) break
						}
# ENSURE THAT POINTS DO NOT CONVERGE TOO CLOSE TO PREVIOUS SOLUTIONS						
						if (any(sqrt(apply(as.matrix(results - rand)**2, 1, sum)) < 0.1, na.rm=TRUE)) next
						temp <- c(solutions, rand)
						temp.coefs <- qr.coef(qr.eqs, temp)
# ENSURE THAT STAY WITHIN BOUNDARY LIMITS FOR A COEFFICIENT (0<=X<=1)
						if (any(temp.coefs < 0 & temp.coefs > 1)) next
						score <- sum(abs(rowSums(t(t(opt.eval)*temp.coefs))-SNR.avg))
						if (is.na(score)) next
						if (count <= 0) {
							rand <- coefs
							score <- score.best	
						}
						if (score <= score.best) break
						count <- count-1
					}
					if ((max(abs(range)) < tol | abs(score.best - score) < tol) & count<=90) break
					if (max(abs(range)) > tol & (score == score.best)) break
					coefs <- rand
					range <- range * min(0.9, max(0.5, score/score.best, na.rm=TRUE))
					score.best <- score
					if (max(abs(range)) < tol) range <- range / tol
				}			
				results[i, ] <- coefs
				coefs <- rep(0.5, length(coefs))
				scores[i] <- score.best
				score.best <- Inf
				range <- (-500000:500000)/1000000
			}
			score.worst <- max(scores, na.rm=TRUE)
			slope <- apply(as.matrix(apply(as.matrix(results), 2, diff)), 2, mean)
			results.avg <- apply(as.matrix(results), 2, mean)
			limit.max <- (rep(1, length(rand)) - results.avg)/slope
			which.dim <- which.min(abs(limit.max))
			rand.max <- limit.max[which.dim]*slope + results.avg
			limit.min <- (rep(0, length(rand)) - results.avg)/slope
			which.dim <- which.min(abs(limit.min))
			rand.min <- limit.min[which.dim]*slope + results.avg
			incr <- (rand.max-rand.min)/50
			results <- rep(-1, 51)		
			for (i in 1:51) {
				temp <- c(solutions, rand.min + (i - 1)*incr)
				temp.coefs <- qr.coef(qr.eqs, temp)
				if (any(temp.coefs < 0 & temp.coefs > 1)) next
				score <- sum(abs(rowSums(t(t(opt.eval)*temp.coefs))-SNR.avg))
				results[i] <- score
			}
			results <- which(results <= score.worst + tol*10)
			if (length(results) < 1) {
				return(results.avg)
			}
			rand.max <- rand.min + (results[length(results)] - 1)*incr
			rand.min <- rand.min + (results[1] - 1)*incr
			return((rand.min + rand.max)/2)
		}
##
##
################################################################################################
		
		solutions <- c(solutions, optimizeCoefficients())
		qr.coefs <- qr.coef(qr(linear.eqs), solutions)
	}
	
################################################################################################
## DEFINE METHYLATION CALCULATION SUB-FUNCTION 
################################################################################################
	calcMeth.sub <- function(SNR.list) {
		numerator <- 0
		denominator <- 0
		N <- length(SNR.list)
		SNR.sum <- sum(SNR.list, na.rm=TRUE)	
		for (i in 1:N) {
			SNR.i <- SNR.list[i]
			if (is.na(SNR.i)) next
			denominator <- denominator + SNR.i
			switch(method,
				   "weighted" = numerator <- numerator + (i - 1) * SNR.i / (N - 1),
				   "proportion" = numerator <- numerator + min(1, i - 1) * SNR.i
				   )
		}
		if ((denominator <= 0) | (numerator < 0)) return(NA)
		return(min(1, numerator / denominator))
	}
##
##
################################################################################################
	
	results <- c()
	for (i in 1:num.fragments) {
		results <- c(results, calcMeth.sub(SNR.list[cg.list[[i]]]*qr.coefs[(i - 1)*num.SNRs + cg.list[[i]]]))
	}
	names(results) <- cgs
	return(results)
}


analyzeCpGs <- function(fragments, peaks, method=c("weighted", "proportion")) {
	## HOW MANY CGs TO ANALYZE?
	CpG.num <- sum(unlist(lapply(fragments, slot, "CpGs"))[!unlist(lapply(fragments, slot, "conversion.control"))])
	## STORE CG DATA AS NUMERIC VECTOR
	CpG.data <- rep(NA, CpG.num)
	## IDENTIFY FRAGMENTS THAT HAVE CGs AND ARE NOT CONVERSION CONTROLS
	CpGs <- which((unlist(lapply(fragments, slot, "CpGs")) > 0) & (!unlist(lapply(fragments, slot, "conversion.control"))))
	CpG.fragment.map <- c()
	for (i in CpGs) {
		CpG.fragment.map <- c(CpG.fragment.map, rep(i, fragments[[i]]$CpGs))
	}
	for (i in 1:CpG.num) {
		collisions.i <- CpG.fragment.map[i]
		## FRAGMENT COLLISIONS WITH CpG-CONTAINING FRAGMENTS (IDENTIFY TOTAL SET/STRING OF OVERLAPPING FRAGMENTS)
		repeat {
			temp <- collisions.i
			for (collision in collisions.i) {
				temp <- unique(c(temp, unlist(fragments[[collision]]$collision.IDs)))
			}
			if (identical(collisions.i, temp)) break
			collisions.i <- temp
		}
		## WHAT IS EXPECTED MOLECULAR WEIGHT FOR EACH FRAGMENT?
		MWs <- unique(unlist(lapply(fragments[collisions.i], slot, "MW")))
		MWs <- MWs[order(MWs)]
		## MAP ALL COLLIDING FRAGMENTS TO LIST OF MOLECULAR WEIGHTS
		collisions.i <- lapply(MWs, 
							   function(x) {
								temp <- findFragments(x, fragments)
								IDs <- unlist(lapply(temp, slot, "ID"))
								return(unique(IDs))
							   }
							)
		## IDENTIFY WHICH FRAGMENTS ARE NON-CONTRIBUTORY TO METHYLATION STATE (E.G. NON-CG-CONTAINING FRAGMENTS)
		non.cg.fragments <- setdiff(unlist(collisions.i), CpG.fragment.map)
		## IDENTIFY PEAKS AMONG PEAKLIST THAT MAP TO INPUT MOLECULAR WEIGHTS
		which.peaks.matched <- findPeaks(MWs, unlist(lapply(peaks, slot, "MW.actual")))
		which.peaks.matched.theory <- findPeaks(MWs, unlist(lapply(peaks, slot, "MW.theoretical")))
		which.peaks.matched[which(is.na(which.peaks.matched))] <- which.peaks.matched.theory[which(is.na(which.peaks.matched))]
		## EXTRACT SIGNAL-TO-NOISE RATIO (SNR) INFORMATION FOR EACH PEAK
		SNR.list <- which.peaks.matched
		## HANDLE CASES WHERE UNABLE TO FIND ONE OR MORE PEAKS => INDETERMINATE METHYLATION INFORMATION
		if (any(!is.na(which.peaks.matched))) {
			SNR.list[which(!is.na(which.peaks.matched))] <- unlist(lapply(peaks[which.peaks.matched[which(!is.na(which.peaks.matched))]], slot, "SNR"))
		}
		## CALCULATE PERCENT METHYLATION
		CpG.data[i] <- calcMeth(SNR.list, fragments=collisions.i, non.cg.fragments=non.cg.fragments, method=method, na.rm=TRUE)[as.character(CpG.fragment.map[i])]
	}
	return(CpG.data)
}

ampliconPrediction <- function(sequence, 
		lower.threshold=1500, 
		upper.threshold=7000,
		fwd.tag="AGGAAGAGAG", 
		rev.tag="AGCCTTCTCCC",
		plot=TRUE,
		table=TRUE,
		lwd=1,
		cex=1,
		multiple.conversion=FALSE) {
	sequence <- gsub("[^ACGTNXYR.()><]", "", toupper(sequence))
	fwd.tag <- gsub("[^ACTG]", "", toupper(fwd.tag))
	rev.tag <- gsub("[^ACTG]", "", toupper(rev.tag))
	lower.threshold <- as.numeric(lower.threshold)
	upper.threshold <- as.numeric(upper.threshold)
	N <- gregexpr("[CY][.()><]*[GR]", paste(fwd.tag, sequence, rev.tag, sep=""))[[1]]
	if (N[1] < 0) {
		stop("Input sequence contains no CG dinucleotides")
	}
	else {
		N <- length(N)
	}
	CpGs <- matrix(TRUE, nrow=N, ncol=6, dimnames=list(1:N, c("required", "summary", "T+", "C+", "T-", "C-")))
	if (plot) {
		plot(0, type="n", 
			xlim=c(1, 1000), 
			ylim=c(1, 5), xlab="Nucleotide position (bp)", ylab="",
			main="inSilico Assay Prediction", axes=FALSE)
		usr <- par("usr")
		scale <- function (x, min1, max1, min2=usr[1], max2=usr[2]) {
			return(min2 + (x - min1) * (max2 - min2) / (max1 - min1))
		}
	}
	## IN SILICO PREDICTION FOR BOTH FWD AND REV REACTIONS (+/- STRANDS, RESPECTIVELY)
	for (strand in c("+", "-")) {
		switch(strand,
			## STANDARD REV-T7 RXN
			"+" = sequence.i <- sequence,
			## PERFORM ASSAY ON OPPOSITE STRAND, USE FWD-T7
			"-" = {
			   sequence.i <- revComplement(sequence)
			   if (dim(CpGs)[1] > 1) {
				CpGs <- CpGs[N:1, ]
			   }
			}
		)
		required <- gregexpr("[(][ACGTNNXYR.]+[)]", sequence.i)[[1]]
		sequence.i <- gsub("[()]", "", sequence.i)
		attr(required, "match.length") <- attr(required, "match.length") - 2
		required <- required + nchar(fwd.tag)
		required <- required - 2 * (1:length(required) - 1)
		for (primer.flags in gregexpr("[<>]", sequence.i)[[1]]) {
			adjust.length <- (required <= primer.flags & required + attr(required, "match.length") - 1 >= primer.flags)
			attr(required[adjust.length], "match.length") <- attr(required[adjust.length], "match.length") - 1
			adjust.position <- (required >= primer.flags)
			required[adjust.position] <- required[adjust.position] - 1
		}
		fwd.primer <- max(0, attr(regexpr("^[^>]*(?=[>])", sequence.i, perl=TRUE), "match.length"))
		rev.primer <- max(0, attr(regexpr("(?<=[<])[^<]*$", sequence.i, perl=TRUE), "match.length"))
		sequence.i <- gsub("[<>]", "", sequence.i)
		N.seq <- nchar(paste(fwd.tag, sequence.i, rev.tag, sep=""))
		## IN SILICO PREDICTION FOR BOTH T&C REACTIONS
		for (rxn in c("T", "C")) {
			fragments <- inSilicoFragmentation(sequence.i, fwd.tag, rev.tag, type=rxn, lower.threshold, upper.threshold, fwd.primer, rev.primer, multiple.conversion)
			fragment.starts <- unlist(lapply(fragments, slot, "position"))
			fragment.ends <- fragment.starts + unlist(lapply(fragments, slot, "length")) - 1
			primer.fragments <- which((fragment.ends <= nchar(fwd.tag) + fwd.primer) | (fragment.starts >= nchar(sequence.i) + nchar(fwd.tag) - rev.primer + 1))
			for (i in primer.fragments) {
				fragments[[i]]$primer <- TRUE
			}
			for (i in required) {
				fragments.i <- which((fragment.ends >= i) & (fragment.starts <= i + attr(required, "match.length")[which(required == i)] - 1))
				for (j in fragments.i) {
					fragments[[j]]$required <- TRUE
				}
			}
			## IDENTIFY FRAGMENTS THAT HAVE CGs AND ARE NOT CONVERSION CONTROLS
			CpG.positions <- gregexpr("[CY][GR]", paste(fwd.tag, sequence.i, rev.tag, sep=""))[[1]]
			CpG.fragments <- unlist(lapply(CpG.positions, 
				function(x) {
					positions <- unlist(lapply(fragments, slot, "position"))
					lengths <- unlist(lapply(fragments, slot, "length"))
					return(which(x >= positions & x < positions + lengths))
				}
			))
			for (i in 1:N) {
				CpGs[i, "required"] <- CpGs[i, "required"] & fragments[[CpG.fragments[i]]]$required
#				if (fragments[[CpG.fragments[i]]]$CpGs > 1) {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], fragments[[CpG.fragments[i]]]$CpGs, sep="")
#				}
#				else {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], ".", sep="")
#				}
#				collisions <- fragments[[CpG.fragments[i]]]$collision.IDs
#				CpG.collisions <- unlist(lapply(collisions,
#					function(x) {
#						if (is.null(x) | identical(x, integer(0))) return(0)
#						return(length(which((unlist(lapply(fragments[x], slot, "CpGs")) > 0)
#							& !(unlist(lapply(fragments[x], slot, "conversion.control"))))))
#					}
#				))
#				if (any(CpG.collisions > 0)) {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], "D", sep="")
#				}
#				else {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], ".", sep="")
#				}
#				collisions <- fragments[[CpG.fragments[i]]]$collisions
#				if (any(collisions - CpG.collisions > 0)) {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], "O", sep="")
#				}
#				else {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], ".", sep="")
#				}
#				if (fragments[[CpG.fragments[i]]]$primer) {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], "P", sep="")
#				}
#				else {
#					CpGs[i, paste(rxn, strand, sep="")] <- paste(CpGs[i, paste(rxn, strand, sep="")], ".", sep="")
#				}				
				CpGs[i, paste(rxn, strand, sep="")] <- fragments[[CpG.fragments[i]]]$assayable
			}		
			## DISPLAY FRAGMENTATION PROFILES GRAPHICALLY
			if (plot) {
				fragment.margin <- 5.5-(which(paste(rxn, strand, sep="") == c("T+", "C+", "T-", "C-")))
				sequence.start <- scale(nchar(fwd.tag), 1, N.seq)
				sequence.end <- scale(N.seq - nchar(rev.tag) + 1, 1, N.seq)
				## PLOT SEQUENCE TAGS AND LABELS
				rect(scale(1, 1, N.seq), 
					scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
					sequence.start, 
					scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
					col="yellow", border="yellow"
				)
				rect(sequence.end, 
					scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
					scale(N.seq, 1, N.seq), 
					scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
					col="yellow", border="yellow"
				)
				if (strand == "-") {
					CpG.positions <- rev(N.seq - (CpG.positions + 1) + 1)
				}
				collision.count <- c()
				## PLOT EACH FRAGMENT, ONE AT A TIME
				for (fragment.i in fragments) {
					if (strand == "-") {
						fragment.i$position <- as.integer(N.seq - (fragment.i$position + fragment.i$length - 1) + 1)
					}
					CpGs.i <- which(CpG.positions >= fragment.i$position & CpG.positions < fragment.i$position + fragment.i$length)
					## DISPLAY FRAGMENTATION PROFILE
					segment.start <- scale(fragment.i$position, 1, N.seq)
					segment.end <- scale(fragment.i$position + fragment.i$length - 0.01, 1, N.seq)
					## HIGHLIGHT REQUIRED FRAGMENTS (USER-SPECIFIED)
					if (fragment.i$required) {
						rect(segment.start,
							scale(fragment.margin - 0.325, 1, 5, usr[3], usr[4]), 
							segment.end,
							scale(fragment.margin + 0.2, 1, 5, usr[3], usr[4]),
							col="#FFEEFF", border="#FFEEFF"
						)	
					}
					## HIGHLIGHT FRAGMENTS THAT ARE LOCATED WITHIN PRIMERS (DO NOT REPEAT HIGHLIGHTING OF TAG SEQUENCES)
					if (fragment.i$primer & fragment.i$position < N.seq - nchar(rev.tag) + 1 & fragment.i$position + fragment.i$length - 1 > nchar(fwd.tag)) {
#						rect(max(segment.start, scale(nchar(fwd.tag) + 1, 1, N.seq)), 
						rect(max(segment.start, scale(nchar(fwd.tag), 1, N.seq)), 
							scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
#							min(segment.end, scale(N.seq - nchar(rev.tag), 1, N.seq)), 
							min(segment.end, scale(N.seq - nchar(rev.tag) + 1, 1, N.seq)), 
							scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
							col="#FFFFCC", border="#FFFFCC"
						)
					}
					## IS THIS FRAGMENT ASSAYABLE (I.E. BETWEEN THE LOWER/UPPER MW THRESHOLDS)?
					if (fragment.i$assayable) {
						## SELECT APPROPRIATE COLORS FOR EACH FRAGMENT
						if (fragment.i$conversion.control) {
							color.i <- "green"
						}
						else if (fragment.i$CpGs > 0) {
							color.i <- "blue"	
						}
						else {
							color.i <- "black"
						}
						if (sum(fragment.i$collisions) > 0) {
							color.i <- "red" #FF6600
						}
						## PLOT FRAGMENT DELIMITERS
						segments(segment.start, 
							scale(fragment.margin - 0.125, 1, 5, usr[3], usr[4]), 
							segment.start, 
							scale(fragment.margin + 0.125, 1, 5, usr[3], usr[4]), 
							col=color.i, lwd=lwd/2
						)
						segments(segment.end, 
							scale(fragment.margin - 0.075, 1, 5, usr[3], usr[4]), 
							segment.end, 
							scale(fragment.margin + 0.075, 1, 5, usr[3], usr[4]), 
							col=color.i, lwd=lwd/2
						)
					}
					## ELSE... FRAGMENT IS NOT ASSAYABLE
					else {
						color.i <- "gray"
					}
					## FINISH PLOTTING FRAGMENTATION (HORIZONTAL SEGMENTS)
					segments(segment.start, 
						scale(fragment.margin, 1, 5, usr[3], usr[4]), 
						segment.end, 
						scale(fragment.margin, 1, 5, usr[3], usr[4]), 
						col=color.i, lwd=lwd/2
					)
					## PLOT CGs ALONG FRAGMENTATION PROFILE
					if ((fragment.i$CpGs > 0) & !fragment.i$conversion.control) {
						CpG.positions.i <- scale(CpG.positions[CpGs.i], 1, N.seq)
						points(CpG.positions.i, 
							rep(scale(fragment.margin, 1, 5, usr[3], usr[4]), length(CpGs.i)), 
							pch=19, col=color.i, cex=0.5*cex
						)
						text(CpG.positions.i, 
							rep(scale(fragment.margin + 0.225, 1, 5, usr[3], usr[4]), length(CpGs.i)), 
							labels=c(CpGs.i[1], rep("-", length(CpGs.i) - 1)), 
							cex=0.4*cex, col=color.i
						)
					}
				}
				## PLOT SEQUENCE TAGS AND LABELS
				segments(c(sequence.start, sequence.end), 
					scale(fragment.margin - 0.325, 1, 5, usr[3], usr[4]), 
					c(sequence.start, sequence.end), 
					scale(fragment.margin + 0.225, 1, 5, usr[3], usr[4]), 
					col="black", lwd=lwd
				)
				text(c(sequence.start, sequence.end), 
					scale(fragment.margin + 0.325, 1, 5, usr[3], usr[4]), 
					labels=paste(c(paste(rxn, "(", strand, ") 1", sep=""), (N.seq - nchar(fwd.tag) - nchar(rev.tag))), "bp"), 
					cex=0.75*cex
				)
				## DISPLAY WHICH CpG-CONTAINING FRAGMENTS COLLIDE WITH WHICH OTHER CpG-CONTAINING FRAGMENTS
				collision.count <- c()
				for (fragment.i in fragments) {
					if ((fragment.i$CpGs < 1) | (!fragment.i$assayable) | (length(unlist(fragment.i$CG.collision.IDs)) < 1)) next
					if (strand == "-") {
						fragment.i$position <- as.integer(N.seq - (fragment.i$position + fragment.i$length - 1) + 1)
					}
					CGs.i <- which(CpG.positions >= fragment.i$position & CpG.positions < fragment.i$position + fragment.i$length)
					points(scale(CpG.positions[CGs.i], 1, N.seq), 
						rep(scale(fragment.margin - 0.15, 1, 5, usr[3], usr[4]), length(CGs.i)), 
						pch=17, col="gray", cex=0.4*cex
					)
					CG.collisions <- unlist(fragment.i$CG.collision.IDs)
					if (strand == "-") CG.collisions <- N - CG.collisions + 1
					CG.collisions <- unique(c(CG.collisions, CGs.i))
					if (all(!collision.count %in% CG.collisions)) {
						collision.count <- c(collision.count, CGs.i[1])
						segments(scale(min(CpG.positions[CG.collisions]), 1, N.seq),
							scale(fragment.margin - 0.175 - 0.05*length(collision.count), 1, 5, usr[3], usr[4]),
							scale(max(CpG.positions[CG.collisions]), 1, N.seq),
							scale(fragment.margin - 0.175 - 0.05*length(collision.count), 1, 5, usr[3], usr[4]),
							lty="solid", col="gray", lwd=lwd/2
						)
						segments(scale(CpG.positions[CG.collisions], 1, N.seq),
							rep(scale(fragment.margin - 0.15, 1, 5, usr[3], usr[4]), length(CG.collisions)),
							scale(CpG.positions[CG.collisions], 1, N.seq),
							scale(fragment.margin - 0.175 - 0.05*length(collision.count), 1, 5, usr[3], usr[4]),
							lty="solid", col="gray", lwd=lwd/2
						)
					}
				}
			}
		}
	}
	if (plot) {
		for (i in 1:N.seq) {
			text(scale(i, 1, N.seq), 
				 scale(1.05, 1, 5, usr[3], usr[4]), 
				 labels=substr(paste(fwd.tag, revComplement(sequence.i), rev.tag, sep=""), i, i), 
				 cex=0.2*cex
				 )
		}
	}
	if (N > 1) {
		CpGs <- CpGs[N:1, ]
	}
	CpG.counts <- matrix(0, nrow=2, ncol=7, dimnames=list(c("all", "required"), c("summary", "+", "T+", "C+", "-", "T-", "C-")))
	for (i in 1:N) {
		CpGs[i, "summary"] <- any(CpGs[i, c("T+", "C+", "T-", "C-")])
		if (CpGs[i, "summary"]) CpG.counts[1, "summary"] <- CpG.counts[1, "summary"] + 1
		if (CpGs[i, "T+"]) CpG.counts[1, "T+"] <- CpG.counts[1, "T+"] + 1
		if (CpGs[i, "C+"]) CpG.counts[1, "C+"] <- CpG.counts[1, "C+"] + 1
		if (any(CpGs[i, c("T+", "C+")])) CpG.counts[1, "+"] <- CpG.counts[1, "+"] + 1
		if (CpGs[i, "T-"]) CpG.counts[1, "T-"] <- CpG.counts[1, "T-"] + 1
		if (CpGs[i, "C-"]) CpG.counts[1, "C-"] <- CpG.counts[1, "C-"] + 1
		if (any(CpGs[i, c("T-", "C-")])) CpG.counts[1, "-"] <- CpG.counts[1, "-"] + 1
		if (CpGs[i, "required"] & CpGs[i, "summary"]) CpG.counts[2, "summary"] <- CpG.counts[2, "summary"] + 1
		if (CpGs[i, "required"] & CpGs[i, "T+"]) CpG.counts[2, "T+"] <- CpG.counts[2, "T+"] + 1
		if (CpGs[i, "required"] & CpGs[i, "C+"]) CpG.counts[2, "C+"] <- CpG.counts[2, "C+"] + 1
		if (CpGs[i, "required"] & any(CpGs[i, c("T+", "C+")])) CpG.counts[2, "+"] <- CpG.counts[2, "+"] + 1
		if (CpGs[i, "required"] & CpGs[i, "T-"]) CpG.counts[2, "T-"] <- CpG.counts[2, "T-"] + 1
		if (CpGs[i, "required"] & CpGs[i, "C-"]) CpG.counts[2, "C-"] <- CpG.counts[2, "C-"] + 1
		if (CpGs[i, "required"] & any(CpGs[i, c("T-", "C-")])) CpG.counts[2, "-"] <- CpG.counts[2, "-"] + 1
	}
	return(list(summary=CpGs, counts=CpG.counts))
}

setGeneric("revComplement", 
	function(x) {
		standardGeneric("revComplement")
	}
)

setMethod("revComplement", 
	signature = c("character"),
	function(x) {
		x <- toupper(x)
		x <- chartr("ATCGYR()<>", "TAGCRY)(><", x)
		x <- paste(rev(unlist(strsplit(x, ""))), sep="", collapse="")
		return(as.character(x))
	}
)

setMethod("revComplement", 
	signature = c("MassArrayData"),
	function(x) {
		if (!validObject(x)) {
			stop("input (x) is not a valid object of 'MassArrayData'")
		}
		x@sequence <- revComplement(x@sequence)
		N <- nchar(paste(x@fwd.tag, x@sequence, x@rev.tag, sep=""))
		x@CpG.data <- x@CpG.data[, dim(x@CpG.data)[2]:1]
		x@strand <- c("+", "-")[which(c("+", "-") != x@strand)]
		x@fragments.T <- rev(x@fragments.T)
		x@fragments.T <- lapply(x@fragments.T, 
			function(fragment) {
				fragment$position <- as.integer(N - (fragment$position + fragment$length - 1) + 1)
				return(fragment)
			}
		)
		x@fragments.C <- rev(x@fragments.C)
		x@fragments.C <- lapply(x@fragments.C, 
			function(fragment) {
				fragment$position <- as.integer(N - (fragment$position + fragment$length - 1) + 1)
				return(fragment)
			}
		)
		return(x)
	}
)

setClass("MassArrayFragment",
	representation(
		ID = "integer",
		assay.name = "character",
		name = "character",
		sequence = "character",
		position = "integer",
		length = "integer",
		CpGs = "integer",
		MW = "numeric",
		collisions = "integer",
		collision.IDs = "list",
		CG.collisions = "integer",
		CG.collision.IDs = "list",
		type = "character",
		direction = "character",
		extra = "character",
		bisulfite.converted = "logical",
		assayable = "logical",
		conversion.control = "logical",
		required = "logical",
		ignored = "logical",
		primer = "logical"
	),
	prototype(
		ID = as.integer(-1),
		assay.name = "",
		name = "",
		sequence = "",
		position = as.integer(-1),
		length = as.integer(0),
		CpGs = as.integer(0),
		MW = as.numeric(0),
		collisions = as.integer(0),
		collision.IDs = as.list(NULL),
		CG.collisions = as.integer(0),
		CG.collision.IDs = as.list(NULL),
		type = "T",
		direction = "+",
		extra = "5OH",
		bisulfite.converted = FALSE,
		assayable = FALSE,
		conversion.control = FALSE,
		required = FALSE,
		ignored = FALSE,
		primer = FALSE
	)
)


setMethod("initialize",
	"MassArrayFragment",
	function(.Object,
		ID,
		sequence,
		assay.name = "",
		name = "",
		position = -1,
		type = c("T", "C"),
		direction = c("+", "-"),
		extra = c("5OH", "5PPP-3P", "5PPP-3OH"),
		bisulfite.converted = FALSE,
		assayable = FALSE,
		primer = FALSE,
		...	
	) {
		.Object@ID <- as.integer(ID)
		.Object@assay.name <- as.character(assay.name)
		.Object@name <- as.character(name)
		.Object@sequence <- gsub("[^ATCGYRN()]", "", toupper(sequence))
		.Object@position <- as.integer(position)
		.Object@type <- match.arg(type)
		.Object@direction <- match.arg(direction)
		.Object@extra <- match.arg(extra)
		.Object@bisulfite.converted <- bisulfite.converted
		.Object@assayable <- assayable
		.Object@primer <- primer
		.Object@length <- nchar(.Object@sequence)
		.Object@CpGs <- as.integer(countCGs(.Object@sequence))
		.Object@MW <- calcMW(.Object@sequence, rxn=as.character(.Object@type))
		return(.Object)
	}
)


setValidity("MassArrayFragment",
	function(object) {
		return(TRUE)
	}
)


setMethod("$", "MassArrayFragment",
	function (x, name) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			return(NULL)	
		}
		else {
			return(slot(x, name))	
		}
	}
)


setMethod("$<-", "MassArrayFragment",
	function (x, name, value) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			warning("'", name, "' is not a parameter in class 'MassArrayFragment'")
		}
		else {
			slot(x, name) <- value
		}
		return(x)
	}
)

createWiggle <- function(x, file="", append=FALSE, colors=NULL, na.rm=FALSE, sep=" ") {
	N <- length(x$samples)
	if (N < 1) {
		stop("'MassArrayData' object must contain at least one sample")
	}
	position <- position(x)
	chr <- sub("^(chr.*)[:].*$", "\\1", position)
	start <- as.numeric(sub("^.*:([0-9]*)[-].*$", "\\1", position))
	end <- as.numeric(sub("^.*[-]([0-9]*)$", "\\1", position))
	if ((chr == "") | is.na(start) | is.na(end)) {
		stop("'MassArrayData' object does not contain positional information (i.e. 'chr1:27718536-27718918')")
	}
	if (any(is.na(x$CpG.data)) & !na.rm) {
		stop("'MassArrayData' object contains missing methylation values")
	}
	CpG.positions <- gregexpr("[CY][GR]", x$sequence)[[1]]
	sp <- getOption("scipen")
	options(scipen=10)
	if (!append) {
		cat("browser full altGraph\n", file=file)
	}
	hex.map <- matrix(data=c(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15),dimnames=list(c(0,1,2,3,4,5,6,7,8,9,"A","B","C","D","E","F"),10))
	hex.to.10 <- function (hex) {
		digits <- unlist(strsplit(hex,split=""))
		base.10 <- 0
		for (i in 1:length(digits)) {
			base.10 <- base.10 + hex.map[digits[i],]*(16**(length(digits)-i))
		}
		return(base.10)
	}
	if (is.null(colors)) {
		colors <- rainbow(n=N, start=0, end=2/3)
	}
	if (length(colors) != N) {
		colors <- rainbow(n=N, start=0, end=2/3)
	}
	for (i in 1:length(colors)) {
		colors[i] <- paste(hex.to.10(substr(colors[i], 2, 3)),
							hex.to.10(substr(colors[i], 4, 5)),
							hex.to.10(substr(colors[i], 6, 7)), sep=",")
	}
	for (i in 1:N) {
		cat("track type=wiggle_0 name=\"", samples(x)[i], "\" description=\"MassArrayData\" visibility=full autoScale=off color=", colors[i], " altColor=", colors[i], " priority=", i, " yLineOnOff=on yLineMark=0\n", file=file, append=TRUE, sep="")
		if (any(is.na(x$CpG.data[i, ]))) {
			not.na <- which(!is.na(x$CpG.data[i, ]))
			apply(cbind(chr[not.na], start[not.na] + CpG.positions[not.na] - 1, start[not.na] + CpG.positions[not.na], x$CpG.data[i, not.na]), 1, cat, "\n", sep=sep, file=file, append=TRUE)
			rm(not.na)
		}
		else {
			apply(cbind(chr, start + CpG.positions - 1, start + CpG.positions, x$CpG.data[i, ]), 1, cat, "\n", sep=sep, file=file, append=TRUE)
		}
	}
	
	
	
	options(scipen=sp)	
}

setClass("MassArrayData",
	representation(
		sequence = "character",
		chr = "character",
		start = "integer",
		end = "integer",
		strand = "character",
		fwd.tag = "character",
		rev.tag = "character",
		fwd.primer = "numeric",
		rev.primer = "numeric",
		lower.threshold = "numeric", 
		upper.threshold = "numeric", 
		fragments.T = "list",
		fragments.C = "list",
		samples = "list",
		groups = "character",
		CpG.data = "matrix",
		CpG.data.combined = "matrix"
	),
	prototype(
		sequence = character(),
		chr = character(),
		start = integer(),
		end = integer(),
		fwd.tag = character(),
		rev.tag = character(),
		fwd.primer = numeric(),
		rev.primer = numeric(),
		lower.threshold = numeric(),
		upper.threshold = numeric(),
		fragments.T = list(),
		fragments.C = list(),
		samples = list(),
		groups = character(),
		CpG.data = matrix(),
		CpG.data.combined = matrix()
	)
)


setMethod("initialize",
	"MassArrayData",
	function (.Object,
		sequence, 
		file = "", 
		verbose=TRUE, 
		fwd.tag="AGGAAGAGAG", 
		rev.tag="AGCCTTCTCCC", 
		fwd.primer=0, 
		rev.primer=0, 
		strand=c("+", "-"), 
		lower.threshold=1500, 
		upper.threshold=9000, 
		header=TRUE, 
		skip=1, 
		sep="\t", 
		comment.char="#", 
		fill=TRUE, 
		method=c("weighted", "proportion"),
		position="",
		multiple.conversion=FALSE,
		...
	) {	
		.Object@strand <- match.arg(strand)
		method <- match.arg(method)
		.Object@sequence <- gsub("[^ACGTNXYR.()><]", "", toupper(sequence))
		.Object@fwd.tag <- gsub("[^ACTG]", "", toupper(fwd.tag))
		.Object@rev.tag <- gsub("[^ACTG]", "", toupper(rev.tag))
		.Object@lower.threshold <- as.numeric(lower.threshold)
		.Object@upper.threshold <- as.numeric(upper.threshold)
		switch(.Object@strand,
			## STANDARD REV-T7 RXN
			"+" = sequence <- .Object@sequence,
			## PERFORM ASSAY ON OPPOSITE STRAND, USE FWD-T7
			"-" = sequence <- revComplement(.Object@sequence)
		)
		required <- gregexpr("[(][ACGTNNXYR.]+[)]", .Object@sequence)[[1]]
		.Object@sequence <- gsub("[()]", "", .Object@sequence)
		attr(required, "match.length") <- attr(required, "match.length") - 2
		required <- required + nchar(.Object@fwd.tag)
		required <- required - 2 * (1:length(required) - 1)
		for (primer.flags in gregexpr("[<>]", .Object@sequence)[[1]]) {
			adjust.length <- (required <= primer.flags & required + attr(required, "match.length") - 1 >= primer.flags)
			attr(required[adjust.length], "match.length") <- attr(required[adjust.length], "match.length") - 1
			adjust.position <- (required >= primer.flags)
			required[adjust.position] <- required[adjust.position] - 1
		}
		if (fwd.primer <= 0) {
			.Object@fwd.primer <- max(0, attr(regexpr("^[^>]*(?=[>])", .Object@sequence, perl=TRUE), "match.length"))
		}
		else {
			.Object@fwd.primer <- fwd.primer	
		}
		if (.Object@fwd.primer <= 0) {
			warning("FWD primer not specified! Please consult the MassArray package manual for details on specifying primers")
		}
		if (rev.primer <= 0) {
			.Object@rev.primer <- max(0, attr(regexpr("(?<=[<])[^<]*$", .Object@sequence, perl=TRUE), "match.length"))
		}
		else {
			.Object@rev.primer <- rev.primer	
		}
		if (.Object@rev.primer <= 0) {
			warning("REV primer not specified! Please consult the MassArray package manual for details on specifying primers")
		}
		.Object@sequence <- gsub("[<>]", "", .Object@sequence)
		position(.Object) <- position
		if (verbose) cat("Performing inSilico Fragmentation: T, ")
		.Object@fragments.T <- inSilicoFragmentation(.Object@sequence, fwd.tag, rev.tag, type="T", .Object@lower.threshold, .Object@upper.threshold, .Object@fwd.primer, .Object@rev.primer, multiple.conversion)
		fragment.starts <- unlist(lapply(.Object@fragments.T, slot, "position"))
		fragment.ends <- fragment.starts + unlist(lapply(.Object@fragments.T, slot, "length")) - 1
		for (i in required) {
			fragments.i <- which((fragment.ends >= i) & (fragment.starts <= i + attr(required, "match.length")[which(required == i)] - 1))
			for (j in fragments.i) {
				.Object@fragments.T[[j]]$required <- TRUE
			}
		}
		if (verbose) cat("C ... ")
		.Object@fragments.C <- inSilicoFragmentation(.Object@sequence, .Object@fwd.tag, .Object@rev.tag, type="C", .Object@lower.threshold, .Object@upper.threshold, .Object@fwd.primer, .Object@rev.primer, multiple.conversion)
		fragment.starts <- unlist(lapply(.Object@fragments.C, slot, "position"))
		fragment.ends <- fragment.starts + unlist(lapply(.Object@fragments.C, slot, "length")) - 1
		for (i in required) {
			fragments.i <- which((fragment.ends >= i) & (fragment.starts <= i + attr(required, "match.length")[which(required == i)] - 1))
			for (j in fragments.i) {
				.Object@fragments.C[[j]]$required <- TRUE
			}
		}

		if (verbose) cat("FINISHED\n")
		if (!file.exists(file)) {
			if (verbose) warning("Cannot open data file:", file)
			CpG.num <- gregexpr("CG", paste(.Object@fwd.tag, .Object@sequence, .Object@rev.tag, sep=""))[[1]]
			if (CpG.num[1] < 0) {
				CpG.num <- 0	
			}
			else {
				CpG.num <- length(CpG.num)
			}
			.Object@CpG.data <- .Object@CpG.data.combined <- matrix(NA, nrow=length(.Object@samples), ncol=CpG.num)
			return(.Object)
		}
		if (verbose) cat("Importing matched peaks file (", file, "):\n", sep="")
	    data <- read.table(file, header=header, skip=skip, sep=sep, comment.char=comment.char, fill=fill)
		## EPITYPER DATA (MATCHED PEAKS) CAN COME IN TWO FORMATS (OLD & NEW) => HANDLE DIFFERENTLY
	    if ("Amplicon" %in% colnames(data)) {
			.Object@samples <- importEpiTyperData.new(data, .Object, verbose)
	    }
	    else {
			.Object@samples <- importEpiTyperData(data, .Object, verbose)
	    }
		if (length(.Object@samples) < 1) return(.Object)
		if (verbose) cat("\tAnalyzing conversion control(s) ... ")
		## CALCULATE CONVERSION CONTROLS FOR EACH SAMPLE
		for (i in 1:length(.Object@samples)) {
			switch(.Object@samples[[i]]$rxn,
				"T" = {
					.Object@samples[[i]]@quality.conversion <- calcPercentConversion(.Object@fragments.T, .Object@samples[[i]]@peaks)
				},
				"C" = {
					.Object@samples[[i]]@quality.conversion <- calcPercentConversion(.Object@fragments.C, .Object@samples[[i]]@peaks)
				}
			)
		}
		## ESTIMATE PRIMER DIMER LEVELS FOR EACH SAMPLE
		if (verbose) cat("FINISHED\n\tEstimating primer dimer level(s) ... ")
		if (.Object@fwd.primer * .Object@rev.primer > 0) {
			for (i in 1:length(.Object@samples)) {
				sample.i <- .Object@samples[[i]]
				switch(sample.i$rxn,
					"T" = primerdimer <- estimatePrimerDimer(.Object@fragments.T, sample.i$peaks),
					"C" = primerdimer <- estimatePrimerDimer(.Object@fragments.C, sample.i$peaks)
				)
				.Object@samples[[i]]$quality.primerdimer <- primerdimer
			}
			if (verbose) cat("FINISHED\n\tEstimating adduct level(s) ... ")
		}
		else {
			if (verbose) cat("ERROR (no primers specified)\n\tEstimating adduct level(s) ... ")	
		}
		## ESTIMATE PREVALENCE OF ADDUCTS IN EACH SAMPLE
		for (i in 1:length(.Object@samples)) {
			sample.i <- .Object@samples[[i]]
			switch(sample.i$rxn,
				   "T" = adduct <- calcPercentAdduct(sample.i$peaks),
				   "C" = adduct <- calcPercentAdduct(sample.i$peaks)
				   )
			.Object@samples[[i]]$quality.adducts <- adduct
		}
		## CALCULATE CpG METHYLATION CALLS FOR CPGS
		if (verbose) cat("FINISHED\n\tAnalyzing CpG methylation ...")
		CpG.num <- gregexpr("CG", paste(.Object@fwd.tag, .Object@sequence, .Object@rev.tag, sep=""))[[1]]
		if (CpG.num[1] < 0) {
			CpG.num <- 0	
		}
		else {
			CpG.num <- length(CpG.num)
		}
		.Object@CpG.data <- matrix(NA, nrow=length(.Object@samples), ncol=CpG.num)
		if (length(.Object@samples) > 0) {
			for (i in 1:length(.Object@samples)) {
				if (verbose) cat(".")
				sample.i <- .Object@samples[[i]]
				switch(sample.i$rxn,
					"T" = CpG.data.i <- rev(analyzeCpGs(.Object@fragments.T, sample.i$peaks, method)),
					"C" = CpG.data.i <- rev(analyzeCpGs(.Object@fragments.C, sample.i$peaks, method))
				)
				.Object@CpG.data[i, ] <- CpG.data.i
			}
		}
		.Object@CpG.data.combined <- .Object@CpG.data

		if (verbose) cat(" FINISHED\n")
		return(.Object)
	}
)


setValidity("MassArrayData",
	function(object) {
		## TEST WHETHER CpG COUNT MATCHES IN BOTH T&C RXN
		CpG.num <- length(gregexpr("CG", paste(object@fwd.tag, object@sequence, object@rev.tag, sep=""))[[1]])
		CpGs.T <- which(unlist(lapply(object@fragments.T, slot, "CpGs")) > 0 & !unlist(lapply(object@fragments.T, slot, "conversion.control")))
		CpGs.T <- CpGs.T[which(!duplicated(unlist(lapply(object@fragments.T[CpGs.T], slot, "position"))))]
		CpG.num.T <- sum(unlist(lapply(object@fragments.T[CpGs.T], slot, "CpGs")))
		if (!identical(CpG.num, CpG.num.T)) return(FALSE)
		CpGs.C <- which(unlist(lapply(object@fragments.C, slot, "CpGs")) > 0 & !unlist(lapply(object@fragments.C, slot, "conversion.control")))
		CpGs.C <- CpGs.C[which(!duplicated(unlist(lapply(object@fragments.C[CpGs.C], slot, "position"))))]
		CpG.num.C <- sum(unlist(lapply(object@fragments.C[CpGs.C], slot, "CpGs")))
		if (!identical(CpG.num, CpG.num.C)) return(FALSE)
		## TEST WHETHER SAMPLE COUNT MATCHES CpG METHYLATION DATA
		if (!identical(length(object@samples), dim(object@CpG.data)[1])) return(FALSE)
		## TEST IF POSITIONAL INFORMATION CONTAINS VALID BOUNDARIES (I.E. START <= END)
		if ((length(object@start) > 0) & (length(object@end > 0))) {
			if (object@start > object@end) return(FALSE)
		}
		return(TRUE)
	}
)

setMethod("$", "MassArrayData",
	function (x, name) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			return(NULL)	
		}
		else {
			return(slot(x, name))	
		}
	}
)


setMethod("$<-", "MassArrayData",
	function (x, name, value) {
		if (inherits(try(slot(x, name), silent=TRUE), "try-error")) {
			warning("'", name, "' is not a parameter in class 'MassArrayData'")
		}
		else {
			slot(x, name) <- value
		}
		return(x)
	}
)


setMethod("[", "MassArrayData",
	function (x, i, j, ..., drop=NA) {
		if (!validObject(x)) {
			stop("not a valid object of 'MassArrayData'")
		}
		if (!missing("i")) {
			if (is.logical(i)) {
				if (length(i) != length(x@samples)) {
					stop("(subscript 'i') logical subscript does not match dimensions of MassArrayData object")
				}
				i <- which(i)
			}
			if (is.character(i)) {
				matched <- match(samples(x), i)
				i <- which(!is.na(matched))
			}
			i <- as.integer(i)
			if (is.integer(i)) {
				if (length(i) < 1) {
					x@samples <- list()
					x@CpG.data <- x@CpG.data.combined <- matrix(nrow=0, ncol=dim(x@CpG.data)[2])
					x@groups <- character()
					return(x)	
				}
				if (max(i) > length(x@samples) | min(i) < 1) {
					stop("(subscript 'i') subscript out of bounds")
				}
				samples <- list()
				for (sample.i in i) {
					samples <- c(samples, x@samples[[sample.i]])
				}
				x@samples <- samples
				x@CpG.data <- matrix(x@CpG.data[i, ], ncol=dim(x@CpG.data)[2], dimnames=list(samples(x), 1:dim(x@CpG.data)[2]))
				x@CpG.data.combined <- matrix(x@CpG.data.combined[which(!is.na(match(unique(samples(x)), samples(x)))), ], ncol=dim(x@CpG.data)[2], dimnames=list(unique(samples(x)), 1:dim(x@CpG.data)[2]))
				x@groups <- x@groups[i]
			}
		}
		if (!missing("j")) {
			if (is.character(j)) {
				stop("(subscript 'j') subscript must contain numeric or logical input")
			}
			if (is.logical(j)) {
				if (length(j) != dim(x@CpG.data)[2]) {
					stop("(subscript 'j') logical subscript does not match dimensions of MassArrayData object")
				}
				j <- which(j)
			}
			j <- as.integer(j)
			if (is.integer(j)) {
				if (max(j) > dim(x@CpG.data)[2] | min(j) < 1) {
					stop("(subscript 'j') subscript out of bounds")
				}
				x@CpG.data <- matrix(x@CpG.data[, j], ncol=length(j), dimnames=list(samples(x), j))
				x@CpG.data.combined <- matrix(x@CpG.data.combined[, j], ncol=length(j), dimnames=list(samples(x), j))
				## REMOVE CGs FROM SEQUENCE AND FRAGMENTATION LISTS
				CG.positions <- unlist(gregexpr("(CG|YG|CR)", x@sequence))
				for (CG in CG.positions[setdiff(1:length(CG.positions), j)]) {
					substr(x@sequence, CG, CG) <- "T"
				}
				x@fragments.T <- inSilicoFragmentation(x@sequence, x@fwd.tag, x@rev.tag, type="T", x@lower.threshold, x@upper.threshold, x@fwd.primer, x@rev.primer)
				x@fragments.C <- inSilicoFragmentation(x@sequence, x@fwd.tag, x@rev.tag, type="C", x@lower.threshold, x@upper.threshold, x@fwd.primer, x@rev.primer)
			}
		}
		return(x)
	}
)

importEpiTyperData <- function (data, MassArrayObject, verbose=TRUE) {
	samples <- list()
	assay.rows <- c(grep("^T Methyl ", as.character(data[, 1])) - 1, dim(data)[1] + 1)
	if (length(assay.rows) <= 1) {
		if (verbose) warning("File does not contain an identifiable assay")
		return(samples)
	}
	else if (length(assay.rows) > 2) {
	   	if (verbose) warning("File contains multiple assays (please export data as a single assay per file)")
	   	return(samples)
	}
	if (verbose) cat("\tReading assay (", as.character(data[assay.rows[1], 1]), ")", sep="")
	assay.data <- data[assay.rows[1]:(assay.rows[2] - 1), ]
	T.row.divider <- grep("^T Methyl ", as.character(assay.data[, 1]))
	C.row.divider <- grep("^C Methyl ", as.character(assay.data[, 1]))
	T.data <- assay.data[T.row.divider:(C.row.divider - 1), ]
	C.data <- assay.data[C.row.divider:dim(assay.data)[1], ]
	T.sample.rows <- grep(" \\[Plate.*\\]$", T.data[, 1])
	T.samples <- sub(" \\[Plate.*\\]$", "", as.character(T.data[T.sample.rows, 1]))
	T.sample.rows <- c(T.sample.rows, dim(T.data)[1] + 1) + 1
	C.sample.rows <- grep(" \\[Plate.*\\]$", as.character(C.data[, 1]))
	C.samples <- sub(" \\[Plate.*\\]$", "", as.character(C.data[C.sample.rows, 1]))
	C.sample.rows <- c(C.sample.rows, dim(C.data)[1] + 1) + 1
	if (verbose) cat(", ", length(T.samples), "T+", length(C.samples), "C rxns (EpiTyper v1.0):\n", sep="")
	for (rxn in c("T", "C")) {
		switch(rxn,
			"T" = num.samples <- length(T.samples),
			"C" = num.samples <- length(C.samples)
		)
		if (num.samples < 1) next
		if (verbose) cat("\t\t", rxn, " reaction:\n", sep="")
		for (i in 1:num.samples) {
			switch(rxn,
				"T" = {
					sample.data <- T.data[T.sample.rows[i]:(T.sample.rows[i + 1] - 2), ]
					sample.name <- T.samples[i]
					sample.fragments <- MassArrayObject@fragments.T
				},
				"C" = {
					sample.data <- C.data[C.sample.rows[i]:(C.sample.rows[i + 1] - 2), ]
					sample.name <- C.samples[i]
					sample.fragments <- MassArrayObject@fragments.C
				}
			)	
			if (verbose) cat("\t\t\tReading sample (", sample.name, ") ... ", sep="")
			sample.fragments.MW <- unlist(lapply(sample.fragments, slot, "MW"))
			peaks <- c()
			for (j in 1:dim(sample.data)[1]) {
				switch(as.character(sample.data[j, grep("Ref[._ ]type", colnames(sample.data), ignore.case=TRUE)]),
					"NAAD" = adduct <- "Na",
					"K-AD" = adduct <- "K",
					adduct <- NULL
				)
				new <- FALSE
				switch(as.character(sample.data[j, grep("Ref[._ ]type", colnames(sample.data), ignore.case=TRUE)]),
					"NAAD" = type <- "Modified",
					"K-AD" = type <- "Modified",
					"UNKN" = {
						if (length(grep("^(Doubly charged|DOUBLY CHARGED)", as.character(sample.data[j, "Description"]))) > 0) type <- "Modified"
						else type <- "Unknown"
					},
					"NEW " = {
						type <- "Unknown"
						new <- TRUE
					},
					"MAIN" = type <- "Expected",
					"METH" = type <- "Expected",
					"NOME" = type <- "Expected",
					"ACYC" = type <- "Modified",
					"MAIN/ANCH" = type <- "Expected",
					"NOME/ANCH" = type <- "Expected",
					type <- "Unknown"
				)
				if (length(grep("^Missing", as.character(sample.data[j, 1]))) > 0) missing <- TRUE
				else missing <- FALSE
				peak.count <- length(which(!is.na(findPeaks(sample.fragments.MW, sample.data[j, grep("Sample.mass", colnames(sample.data), ignore.case=TRUE)]))))
				## SPLIT PEAK DESCRIPTIONS INTO THEIR POTENTIAL AND/OR ACTUAL COMPONENTS
				description <- unlist(strsplit(as.character(sample.data[j, "Description"]), "[;,]"))
				## REMOVE EXTRANEOUS WHITE SPACES
				description <- gsub("[ ]", "", description)
				## REMOVE NUMERICAL LABELS (HOLD POSITIONAL AND/OR SCORING INFORMATION WHICH IS NOT NEEDED HERE)
				description <- sub("([(][0-9.]*[)].*|[@].*)", "", description)
				charge <- length(grep("^(Doubly charged|DOUBLY CHARGED)", description)) + 1
				## REMOVE DOUBLY CHARGED OR ADDUCT LABELS
				description <- sub(".*[Oo][Ff]", "", description)
				## EXTRACT SEQUENCE FROM 5OH-...-3P AND OTHER SIMILAR FRAGMENTS
				description <- unique(sub(".*[-]([ATCG0-9]+)[-].*", "\\1", description))
				peaks <- c(peaks, new("MassArrayPeak", ID=as.integer(j),
					MW.theoretical=sample.data[j, grep("Reference.mass", colnames(sample.data), ignore.case=TRUE)],
					MW.actual=sample.data[j, grep("Sample.mass", colnames(sample.data), ignore.case=TRUE)],
					probability=sample.data[j, "Probability"],
					SNR=sample.data[j, "SNR"],
					height=sample.data[j, "Height"],
					sample.intensity=sample.data[j, grep("Sample.intensity", colnames(sample.data), ignore.case=TRUE)],
					ref.intensity=sample.data[j, grep("Reference.intensity", colnames(sample.data), ignore.case=TRUE)],
					sequence=as.character(description),
					adduct=adduct, type=type, charge=charge, missing=missing, new=new,
					collisions=nchar(gsub("[^;]", "", as.character(sample.data[j, "Description"]))),
					components=peak.count)
				)
			}
			## EXTRACT SEQUENCE INFORMATION FROM REFERENCE PEAK FOR ADDUCTS AND DOUBLY CHARGED FRAGMENTS
			for (i in 1:length(peaks)) {
				if (length(grep("^[0-9]+[.]?[0-9]*$", peaks[[i]]$sequence)) < 1) next
				peaks[[i]]$sequence <- as.character(peaks[[findPeaks(as.numeric(peaks[[i]]$sequence), unlist(lapply(peaks, slot, "MW.theoretical")))]]$sequence)
			}
			## INTRODUCE ARTIFICIAL CONVERSION CONTROLS INTO PEAK SPECTRA (IF NOT ALREADY PRESENT)
			peaks.expected <- lapply(sample.fragments, slot, "MW")
			peaks.expected <- peaks.expected[unlist(lapply(sample.fragments, slot, "conversion.control"))]
			peaks.expected <- unique(unlist(peaks.expected))
			peaks.observed <- unlist(unique(lapply(peaks, slot, "MW.actual")))
			peaks.found <- findPeaks(peaks.expected, peaks.observed, resolution=1)
			if (is.null(peaks.found)) {
				control.peaks.missing <- NULL
			}
			else {
				control.peaks.missing <- which(is.na(peaks.found))
			}
			if (length(control.peaks.missing) > 0) {
				for (k in 1:length(control.peaks.missing)) {
					peaks <- c(peaks, new("MassArrayPeak", ID=j+k,
						MW.theoretical=peaks.expected[control.peaks.missing[k]],
						MW.actual=peaks.expected[control.peaks.missing[k]],
						probability=NA,
						SNR=0,
						height=NA,
						sample.intensity=NA,
						ref.intensity=1,
						adduct=NULL, type="Control", missing=TRUE, new=FALSE,
						collisions=0, components=1))
				}
			}
			samples <- c(samples, new("MassArraySpectrum", sample=sample.name,
					rxn=rxn, strand=MassArrayObject@strand, peaks=peaks)
				)
			if (verbose) cat("FINISHED\n")
		}
	}
	return(samples)
}



importEpiTyperData.new <- function (data, MassArrayObject, verbose=TRUE) {
	samples <- list()
	if (length(unique(as.character(data[, "Amplicon"]))) < 1) {
		if (verbose) warning("File does not contain an identifiable assay")
		return(samples)
	}
	else if (length(unique(as.character(data[, "Amplicon"]))) > 1) {
	    if (verbose) warning("File contains multiple assays (please export data as a single assay per file)")
	    return(samples)
	}
	if (verbose) cat("\tReading assay (", unique(as.character(data[, "Amplicon"])), ")", sep="")
	T.data <- data[grep("^T Methyl ", as.character(data[, "Reaction"])), ]
	C.data <- data[grep("^C Methyl ", as.character(data[, "Reaction"])), ]
	T.samples <- unique(as.character(T.data[, "Sample"]))
	C.samples <- unique(as.character(C.data[, "Sample"]))
	if (verbose) cat(", ", length(T.samples), "T+", length(C.samples), "C rxns (EpiTyper v1.0.5):\n", sep="")
	for (rxn in c("T", "C")) {
		switch(rxn,
			"T" = num.samples <- length(T.samples),
			"C" = num.samples <- length(C.samples)
		)
		if (num.samples < 1) next
		if (verbose) cat("\t\t", rxn, " reaction:\n", sep="")
		for (i in 1:num.samples) {
			switch(rxn,
				"T" = {
					sample.data <- T.data[grep(T.samples[i], as.character(T.data[, "Sample"]), fixed=TRUE), ]
					sample.name <- sub(" \\[Plate.*\\]$", "", T.samples[i])
					sample.fragments <- MassArrayObject@fragments.T
				},
				"C" = {
					sample.data <- C.data[grep(C.samples[i], as.character(C.data[, "Sample"]), fixed=TRUE), ]
					sample.name <- sub(" \\[Plate.*\\]$", "", C.samples[i])
					sample.fragments <- MassArrayObject@fragments.C
				}
			)
			if (verbose) cat("\t\t\tReading sample (", sample.name, ") ... ", sep="")
			sample.fragments.MW <- unlist(lapply(sample.fragments, slot, "MW"))
			peaks <- c()
			for (j in 1:dim(sample.data)[1]) {
				switch(as.character(sample.data[j, grep("Ref[._ ]type", colnames(sample.data), ignore.case=TRUE)]),
					"NAAD" = adduct <- "Na",
					"K-AD" = adduct <- "K",
					adduct <- NULL
				)
				new <- FALSE
				switch(as.character(sample.data[j, grep("Ref[._ ]type", colnames(sample.data), ignore.case=TRUE)]),
					"NAAD" = type <- "Modified",
					"K-AD" = type <- "Modified",
					"UNKN" = {
						if (length(grep("^(Doubly charged|DOUBLY CHARGED)", as.character(sample.data[j, "Description"]))) > 0) type <- "Modified"
						else type <- "Unknown"
					},
					"NEW " = {
						type <- "Unknown"
						new <- TRUE
					},
					"MAIN" = type <- "Expected",
					"METH" = type <- "Expected",
					"NOME" = type <- "Expected",
					"ACYC" = type <- "Modified",
					"MAIN/ANCH" = type <- "Expected",
					"NOME/ANCH" = type <- "Expected",
					type <- "Unknown"
				)
				if (length(grep("^Missing", as.character(sample.data[j, "Peak"]))) > 0) missing <- TRUE
				else missing <- FALSE
				peak.count <- length(which(!is.na(findPeaks(sample.fragments.MW, sample.data[j, grep("Sample.mass", colnames(sample.data), ignore.case=TRUE)]))))
				## SPLIT PEAK DESCRIPTIONS INTO THEIR POTENTIAL AND/OR ACTUAL COMPONENTS
				description <- unlist(strsplit(as.character(sample.data[j, "Description"]), "[;,]"))
				## REMOVE EXTRANEOUS WHITE SPACES
				description <- gsub("[ ]", "", description)
				## REMOVE NUMERICAL LABELS (HOLD POSITIONAL AND/OR SCORING INFORMATION WHICH IS NOT NEEDED HERE)
				description <- sub("([(][0-9.]*[)].*|[@].*)", "", description)
				## IDENTIFY AND THEN REMOVE DOUBLY CHARGED OR ADDUCT LABELS
				charge <- length(grep("^(Doubly charged|DOUBLY CHARGED)", description)) + 1
				description <- sub(".*[Oo][Ff]", "", description)
				## EXTRACT SEQUENCE FROM 5OH-...-3P AND OTHER SIMILAR FRAGMENTS
				description <- unique(sub(".*[-]([ATCG0-9]+)[-].*", "\\1", description))
				peaks <- c(peaks, new("MassArrayPeak", ID=as.integer(j),
					MW.theoretical=sample.data[j, grep("Reference.mass", colnames(sample.data), ignore.case=TRUE)],
					MW.actual=sample.data[j, grep("Sample.mass", colnames(sample.data), ignore.case=TRUE)],
					probability=sample.data[j, "Probability"],
					SNR=sample.data[j, "SNR"],
					height=sample.data[j, "Height"],
					sample.intensity=sample.data[j, grep("Sample.intensity", colnames(sample.data), ignore.case=TRUE)],
					ref.intensity=sample.data[j, grep("Reference.intensity", colnames(sample.data), ignore.case=TRUE)],
					sequence=as.character(description),
					adduct=adduct, type=type, charge=charge, missing=missing, new=new,
					collisions=nchar(gsub("[^;]", "", as.character(sample.data[j, "Description"]))),
					components=peak.count)
				)
			}
			## EXTRACT SEQUENCE INFORMATION FROM REFERENCE PEAK FOR ADDUCTS AND DOUBLY CHARGED FRAGMENTS
			for (i in 1:length(peaks)) {
				if (length(grep("^[0-9]+[.]?[0-9]*$", peaks[[i]]$sequence)) < 1) next
				peaks[[i]]$sequence <- as.character(peaks[[findPeaks(as.numeric(peaks[[i]]$sequence), unlist(lapply(peaks, slot, "MW.theoretical")))]]$sequence)
			}
			## INTRODUCE ARTIFICIAL CONVERSION CONTROLS INTO PEAK SPECTRA (IF NOT ALREADY PRESENT)
			peaks.expected <- lapply(sample.fragments, slot, "MW")
			peaks.expected <- peaks.expected[unlist(lapply(sample.fragments, slot, "conversion.control"))]
			peaks.expected <- unique(unlist(peaks.expected))
			peaks.observed <- unlist(unique(lapply(peaks, slot, "MW.actual")))
			peaks.found <- findPeaks(peaks.expected, peaks.observed, resolution=1)
			if (is.null(peaks.found)) {
				control.peaks.missing <- NULL
			}
			else {
				control.peaks.missing <- which(is.na(peaks.found))
			}
			if (length(control.peaks.missing) > 0) {
				for (k in 1:length(control.peaks.missing)) {
					peaks <- c(peaks, new("MassArrayPeak", ID=j+k,
						MW.theoretical=peaks.expected[control.peaks.missing[k]],
						MW.actual=peaks.expected[control.peaks.missing[k]],
						probability=NA,
						SNR=0,
						height=NA,
						sample.intensity=NA,
						ref.intensity=1,
						adduct=NULL, type="Control", missing=TRUE, new=FALSE,
						collisions=0, components=1))
				}
			}
			samples <- c(samples, new("MassArraySpectrum", sample=sample.name,
					rxn=rxn, strand=MassArrayObject@strand, peaks=peaks)
				)
			if (verbose) cat("FINISHED\n")
		}
	}
	return(samples)
}

setGeneric("position", 
	function(object) {
		standardGeneric("position")
	}
)

setMethod("position", 
	signature = c("MassArrayData"),
	function(object) {
		if (is.null(object@chr) | is.null(object@start) | is.null(object@end)) return("")
		if (identical(object@chr, character(0)) | identical(object@start, integer(0)) | identical(object@end, integer(0))) return("")
		if ((object@chr == "") | is.na(object@start) | is.na(object@end)) return("")
		return(paste("chr", object@chr, ":", object@start, "-", object@end, sep=""))
	}
)

setGeneric("position<-", 
	function(object, value) {
		standardGeneric("position<-")
	}
)

setMethod("position<-", 
	signature = c("MassArrayData", "missing"),
	function(object, value) {
		return(object)	
	}
)

setMethod("position<-", 
	signature = c("MassArrayData", "character"),
	function(object, value) {
		if (length(grep("^chr[1-9A-Z][0-9]?[:][1-9][0-9]*-[1-9]*[0-9]*$", value)) != 1) {
			if (value != "") {
				warning("positional information incorrect (must be of form chrXX:XXXX-XXXX)")
			}
			return(object)
		}
		fields <- unlist(strsplit(value, "[:-]"))
		if (is.na(fields[3])) {
			fields <- c(fields, as.numeric(fields[2]) + object@end - object@start)
		}
		if (fields[3] < fields[2]) {
			warning("positional information out of bounds (end < start)")
			return(object)
		}
		if (as.integer(fields[3]) - as.integer(fields[2]) + 1 != nchar(object@sequence)) {
			warning("positional information does not match sequence length")
			return(object)
		}
		object@chr <- sub("chr", "", fields[1])
		object@start <- as.integer(fields[2])
		object@end <- as.integer(fields[3])
		return(object)	
	}
)

plot.MassArrayData <- function(x, y, ...) UseMethod("plot")


plot.MassArrayData <- function (x, ...,  collapse=TRUE, bars=TRUE, scale=TRUE, sequence=TRUE, labels=TRUE, colors=TRUE, main=position(x), width=1.5) {
	if (!validObject(x)) {
		stop("not a valid object of 'MassArrayData'")
	}
	sequence.tagged <- paste(x$fwd.tag, x$sequence, x$rev.tag, sep="")
	N <- nchar(sequence.tagged)
	CGs <- CG.positions <- gregexpr("(CG|YG|CR)", sequence.tagged)[[1]]
	if (length(CGs) < 1) stop("sequence contains no measurable CpG sites")
	## FOR NOW IGNORE GROUPING/SUBSET INFORMATION!!! => ASSUME ALL SAMPLES WITHIN A MassArrayData OBJECT ARE FROM ONE GROUP
	CGs.num <- dim(x$CpG.data)[2]
	sample.rxns <- unlist(lapply(x$samples, slot, "rxn"))
	sample.names <- samples(x)
	rxns <- unique(sample.rxns)
	num.rxns <- length(rxns)
	if (num.rxns < 1) stop("Spectral data contains no reactions")
	## GROUP METHYLATION DATA INTO ONE OR MORE SUBSETS OF SAMPLES
	if (collapse) {
		if (length(x$groups) < 1) x$groups <- rep("", dim(x$CpG.data)[1])
		x$groups[which(is.na(x$groups))] <- ""
		groups <- length(unique(x$groups))
		error.bars <- data.grouped <- matrix(NA, nrow=groups, ncol=CGs.num)
		rxn <- rep(NA, groups)
		for (i in 1:groups) {
			group.i <- which(x$groups == unique(x$groups)[i])
			if (length(group.i) > 1) {
				error.bars[i, ] <- apply(x$CpG.data[group.i, ], 2, mad, na.rm=TRUE)
				data.grouped[i, ] <- apply(x$CpG.data[group.i, ], 2, mean, na.rm=TRUE)
			}
			else {
				error.bars[i, ] <- NA
				data.grouped[i, ] <- x$CpG.data[group.i, ]
			}
			if (length(unique(sample.rxns[group.i])) > 1) {
				warning("group ('", unique(x$groups)[i], "') contains multiple rxn variants")
				rxn[i] <- "T&C"
			}
			else {
				rxn[i] <- sample.rxns[group.i][1]
			}
		}
		sample.rxns <- rxn
		error.bars[which(is.na(error.bars))] <- 0
		x$CpG.data <- data.grouped
		sample.names <- unique(x$groups)
	}
	else {
		error.bars <- rep(NA, CGs.num)
		bars <- FALSE
	}
	samples.num <- dim(x$CpG.data)[1]

	if (scale) {
		position.units <- "bp"
		CGs <- CGs + 0.5
		if (!is.numeric(width)) width <- 1.5
		if (is.na(width) | is.nan(width)) width <- 1.5
		if (width < 0) width <- abs(width)
		width <- min(width, N)
		ticks <- pretty(1:N, n=ceiling(N/10))
		axis.labels <- pretty(1:N, n=ceiling(N/50))
	}
	else {
		CGs <- 1:length(CGs)
		N <- length(CGs)
		position.units <- "CG number"
		sequence <- FALSE
		width <- 0.25
		ticks <- 1:N
		axis.labels <- 1:N
	}
	## BEGIN PLOTTING
	plot(0, type="n", 
		xlim=c(1, N), 
		ylim=c(0, 10), xlab=paste("Nucleotide position (", position.units, ")", sep=""), ylab="",
		main=main, axes=FALSE)
	axis(1, 
		labels=axis.labels[match(ticks, axis.labels)], 
		at=ticks, 
		cex.lab=0.75, cex.axis=0.75, las=2
	)
	## DEFINE PLOTTING WINDOW AND SCALING FUNCTION
	usr <- par("usr")
	scale <- function (x, min1, max1, min2=usr[1], max2=usr[2]) {
		return(min2 + (x - min1) * (max2 - min2) / (max1 - min1))
	}
	
	if (labels) {
		text(CGs, 
			rep(usr[4], CGs.num), 
			labels=1:CGs.num, 
			cex=0.4, col="black", pos=1
		)
		if (sequence) {
			text(1:N, 
				rep(usr[3], N),
				labels=unlist(strsplit(sequence.tagged, "")),
				cex=0.2, col="darkgray", pos=3
			)
#			text((N + 1)/2, usr[3] + 0.035*(usr[4] - usr[3]), labels=position(x), cex=0.25, col="darkgray")
		}
	}
	else {
		colors <- FALSE	
	}
	for (i in 1:samples.num) {
		if (labels) {
			text(usr[1],
				scale(samples.num - i + 1.5, 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]),
				labels=sample.names[i],
				cex=0.4, col="black", pos=4, srt=90
			)	
			
		}
		switch(sample.rxns[i],
			"T" = fragments <- x$fragments.T,
			"C" = fragments <- x$fragments.C,
			fragments <- c(x$fragments.T, x$fragments.C)
		)
		positions <- unlist(lapply(fragments, slot, "position"))
		lengths <- unlist(lapply(fragments, slot, "length"))
		cg.fragments <- lapply(CG.positions, 
			function (x) {
				return(which(x >= positions & x < positions + lengths))
			}
		)
		for (j in 1:CGs.num) {
			fragment <- fragments[cg.fragments[[j]]]
			shading.density <- NA
			lty <- "solid"
			label.color <- "black"
			label.text <- NA
			if (colors) {
				color.cg <- color.border <- "black"
				color.bg <- "peachpuff"
				if (all(unlist(lapply(fragment, slot, "CpGs")) > 1)) {
					color.bg <- "#FFFFCC"
					color.border <- "peachpuff"
#					lty <- "dotted"
				}
				if (all(unlist(lapply(unlist(lapply(fragment, slot, "CG.collision.IDs"), recursive=FALSE), length)) > 0)) {
					color.bg <- "#FF9900"
				}
			}
			else {
				color.bg <- "#F9F9F9"
				color.cg <- color.border <- "black"
			}
			if (is.na(x$CpG.data[i, j])) {
				color.cg <- color.border <- "#CCCCCC"
				color.bg <- "white"
				shading.density <- NA
#				x$CpG.data[i, j] <- 0
			}
			else if (!any(unlist(lapply(fragment, slot, "assayable")))) {
				color.cg <- color.border <- "#BBBBBB"
				color.bg <- "#EEEEEE"
			}
#			else if (colors) {
#				color.cg <- color.border <- "black"
#				color.bg <- "peachpuff"
#			}
#			else {
#				color.bg <- "#F9F9F9"
#				color.cg <- color.border <- "black"
#			}
			if (all(unlist(lapply(fragment, slot, "required")))) {
#				color.border <- "#DD3333"
				label.text <- "*"
				if (colors) label.color <- "red"
			}
			if (labels & !is.na(label.text)) {
				text(CGs[j], 
					0.98*usr[4], 
					labels=label.text, 
					cex=0.6, col=label.color, pos=1
				)
			}
			rect(CGs[j] - width, 
				scale(samples.num - i + 1.05, 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
				CGs[j] + width, 
				scale(samples.num - i + 1.95, 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
				border=color.border, col=color.bg, lwd=1, lty=lty, density=shading.density
			)
			rect(CGs[j] - width, 
				scale(samples.num - i + 1.05, 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
				CGs[j] + width, 
				scale(samples.num - i + scale(x$CpG.data[i, j], 0, 1, 1.05, 1.95), 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
				border=NA, col=color.cg, lwd=1, lty=lty, density=shading.density
			)
			## DISPLAY ERROR BARS (IF DESIRED)
			if (bars) {
				color.cg <- as.numeric(col2rgb(color.cg))+(as.numeric(col2rgb(color.bg))-as.numeric(col2rgb(color.cg)))/2
				color.cg <- rgb(color.cg[1], color.cg[2], color.cg[3], maxColorValue=255)
				cg <- x$CpG.data[i, j] - c(error.bars[i, j], -error.bars[i, j])
				## SKIP ERROR BAR UNLESS THERE IS NON-ZERO DATA TO PLOT
				if (is.na(x$CpG.data[i, j]) | is.na(error.bars[i, j]) | (error.bars[i, j] <= 0)) next
				## DRAW VERTICAL PORTION OF ERROR BAR
				lines(rep(CGs[j], 2), 
					scale(samples.num - i + scale(c(max(0, cg[1]), min(1, cg[2])), 0, 1, 1.05, 1.95), 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
					col=color.cg, lwd=1)
				## DRAW LOWER DELIMITER OF ERROR BAR
				if (cg[1] > 0) {
					lines(c(CGs[j] - width/3, CGs[j] + width/3), 
						scale(samples.num - i + scale(rep(cg[1], 2), 0, 1, 1.05, 1.95), 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
						col=color.cg, lwd=1)
				}
				## DRAW UPPER DELIMITER OF ERROR BAR
				if (cg[2] < 1) {
					lines(c(CGs[j] - width/3, CGs[j] + width/3), 
						scale(samples.num - i + scale(rep(cg[2], 2), 0, 1, 1.05, 1.95), 1, samples.num + 1, usr[3] + 0.05*(usr[4] - usr[3]), 0.95*usr[4]), 
						col=color.cg, lwd=1)
				}
			}
			
			
		}
				
	}
}

setGeneric("samples", 
	function(object) {
		standardGeneric("samples")
	}
)

setMethod("samples", 
	signature = c("MassArrayData"),
	function(object) {
		return(as.character(unlist(lapply(object@samples, slot, "sample"))))
	}
)

setGeneric("samples<-", 
	function(object, value) {
		standardGeneric("samples<-")
	}
)

setMethod("samples<-", 
	signature = c("MassArrayData", "missing"),
	function(object, value) {
		return(object)	
	}
)

setMethod("samples<-", 
	signature = c("MassArrayData", "character"),
	function(object, value) {
		if (length(value) != length(object@samples)) {
			stop("number of samples does not match number of spectra in 'MassArrayData' object")
		}
		if (length(value) != dim(object@CpG.data)[1]) {
			stop("number of samples does not match dimensions of methylation data in 'MassArrayData' object")
		}
		for (i in 1:length(value)) {
			object@samples[[i]]$sample <- as.character(value[i])
		}
		rownames(object@CpG.data) <- value
		return(object)	
	}
)

inSilicoFragmentation <- function (sequence, fwd.tag="", rev.tag="", type=c("T", "C"), lower.threshold=1500, upper.threshold=7000, fwd.primer=0, rev.primer=0, multiple.conversion=FALSE) {
	type <- match.arg(type)
	bisulfite.sequence <- bisConvert(sequence)
	bisulfite.sequence <- paste(fwd.tag, bisulfite.sequence, rev.tag, sep="")
	## PERFORM IN SILICO DIGEST TO GET LIST OF PREDICTED FRAGMENTS
	revcomp.bis.sequence <- revComplement(bisulfite.sequence)
	CG.positions <- unlist(gregexpr("(CG|YG|CR)", bisulfite.sequence))
	fragments <- rnaDigest(revcomp.bis.sequence, type)
	## RE-ASSIGN POSITIONS TO MAP BACK TO REGULAR (I.E. NOT REV-COMPLEMENTED) SEQUENCE
	fragments <- lapply(fragments, function (x) {
			x$position <- as.integer(nchar(revcomp.bis.sequence) - (x$position + x$length - 1) + 1)
			return(x)
		}
	)
	## EXTRACT POSITIONAL INFORMATION
	positions <- unlist(lapply(fragments, slot, "position"))
	lengths <- unlist(lapply(fragments, slot, "length"))
	ends <- positions + lengths - 1
	## STORE PRIMER INFORMATION IN FRAGMENTATION PATTERN
	primer.fragments <- which((ends <= nchar(fwd.tag) + fwd.primer) | (positions >= nchar(sequence) + nchar(fwd.tag) - rev.primer + 1))
	for (i in primer.fragments) {
		fragments[[i]]$primer <- TRUE
	}
	## 5' MODIFICATION OF FIRST FRAGMENT => UPDATE MOLECULAR WEIGHT
	fragments[[1]]$extra <- "5PPP-3P"
	fragments[[1]]$MW <- calcMW(fragments[[1]]$sequence, "5PPP-3P", rxn=type)
	## GET EXPECTED PEAKS
	fragment.peaks <- lapply(fragments, slot, "MW")
	fragment.IDs <- mapply(rep, 1:length(fragments), lapply(fragment.peaks, length))
	peaks.unique <- unique(unlist(fragment.peaks))
	peaks.unique <- peaks.unique[order(peaks.unique)]
	## WHICH PEAKS ARE ASSAYABLE?
	peaks.assayable <- which(isAssayable(peaks.unique, lower.threshold, upper.threshold))
	## MAP PEAKS TO FRAGMENTS (ONE PEAK MAY MAP TO MULTIPLE)
	peak.fragment.map <- mapply(match, rep(list(peaks.unique), length(fragment.peaks)), fragment.peaks)
	peak.fragment.map <- apply(!apply(peak.fragment.map, 2, is.na), 1, which)
	## IDENTIFY ANY PEAK COLLISIONS (UNIQUE PEAKS, BUT MW TOO CLOSE TO DISTINGUISH SEPARATELY)
	peak.collisions <- findCollisions(peaks.unique)
	for (i in which(lapply(peak.collisions, length) > 1)) {
		for (j in peak.collisions[[i]]) {
			peak.fragment.map[[i]] <- unique(c(peak.fragment.map[[i]], peak.fragment.map[[j]]))
		}	
	}
	## DETERMINE NUMBER OF COMPONENT FRAGMENTS FOR EACH PEAK
	peak.counts <- unlist(lapply(peak.fragment.map, length))
	## STORE PER-FRAGMENT COLLISION DATA (INCLUDES MAP TO OTHER FRAGMENTS FOR EACH PEAK COLLISION)
	CG.fragments <- unlist(lapply(CG.positions, 
		function(x) {
			positions <- unlist(lapply(fragments, slot, "position"))
			lengths <- unlist(lapply(fragments, slot, "length"))
			return(which(x >= positions & x < positions + lengths))
		}
	))
	fragments <- lapply(fragments, function (x) {
			x$collisions <- as.integer(peak.counts[match(x$MW, peaks.unique)] - 1)
			x$collision.IDs <- lapply(peak.fragment.map[match(x$MW, peaks.unique)], setdiff, x$ID)
			## IS THIS A CpG-CONTAINING FRAGMENT?
			if (x$CpGs > 0) {
				## WHICH OF THE FRAGMENT COLLISIONS ALSO CONTAIN CpG?
				CpG.collisions <- lapply(x$collision.IDs,
					function(x) {
						if (is.null(x) | identical(x, integer(0))) return()
						return(x[which((unlist(lapply(fragments[x], slot, "CpGs")) > 0)
							& !(unlist(lapply(fragments[x], slot, "conversion.control"))))])
					}
				)
				x$CG.collision.IDs <- lapply(CpG.collisions,
					function(x) {
						return(which(CG.fragments %in% x))
					}
				)
			}
			return(x)
		}
	)
	## ARE THE FRAGMENTS ASSAYABLE?
	fragments.assayable <- unlist(lapply(relist(isAssayable(unlist(fragment.peaks), lower.threshold, upper.threshold), fragment.peaks), all))
	for (i in which(fragments.assayable)) {
		fragments[[i]]$assayable <- TRUE	
	}
	fragments <- convControl(paste(fwd.tag, sequence, rev.tag, sep=""), fragments, multiple=multiple.conversion)

	return(fragments)
}

setGeneric("combine", 
	function(x, y, ...) {
		standardGeneric("combine")
	}
)

setMethod("combine",
	signature = c("MassArrayData", "missing"),
	function(x, y, ...) {
		if (!validObject(x)) {
			stop("input (x) is not a valid object of 'MassArrayData'")
		}
		sample.names <- samples(x)
		sample.names.unique <- unique(sample.names)
		N <- dim(x@CpG.data)[2]
		x@CpG.data.combined <- matrix(NA, nrow=length(sample.names.unique), ncol=N, dimnames=list(sample.names.unique, 1:N))
		for (i in 1:length(sample.names.unique)) {
			j <- which(sample.names == sample.names.unique[i])
			if (length(j) <= 1) {
				x@CpG.data.combined[i, ] <- x@CpG.data[j, ]
			}
			else {
				x@CpG.data.combined[i, ] <- apply(x@CpG.data[j, ], 2, mean, na.rm=TRUE)
			}
		}
		return(x)
	}
)


setMethod("combine",
	signature = c("MassArrayData", "MassArrayData"),
	function(x, y, ...) {
		if (!validObject(x)) {
			stop("input (x) is not a valid object of 'MassArrayData'")
		}
		if (!validObject(y)) {
			stop("input (y) is not a valid object of 'MassArrayData'")
		}
		if (!identical(x@chr, y@chr)) {
			stop("sequences are non-adjacent (chromosome mismatch)")
		}
		if ((length(x@start) < 1) | (length(x@end) < 1) | (length(y@start) < 1) | (length(y@end) < 1)) {
			stop("positional information not specified -- see position() function")
		}
		original <- x@strand
		## NEED TO UPDATE THIS STRAND SPECIFICITY FOR MASSARRAYDATA OBJECTS!!!
		if (identical(x@strand, "-")) {
			x <- revComplement(x)
		}
		if (identical(y@strand, "-")) {
			y <- revComplement(y)
		}
		bounds <- c(max(x@start, y@start), min(x@end, y@end))
		overlap <- (bounds[1] <= bounds[2])
		bounds <- bounds[order(bounds)]
		x.cgs <- c(gregexpr("(CG|YG|CR)", x@sequence)[[1]] + x@start - 1, bounds)
		y.cgs <- c(gregexpr("(CG|YG|CR)", y@sequence)[[1]] + y@start - 1, bounds)
		cgs <- unique(c(x.cgs, y.cgs, bounds))
		x.cgs <- x.cgs[order(x.cgs)]
		y.cgs <- y.cgs[order(y.cgs)]
		cgs <- cgs[order(cgs)]
		x.A <- which(x.cgs == bounds[1])[1]
		x.B <- which(x.cgs == bounds[2])[1]
		y.A <- which(y.cgs == bounds[1])[1]
		y.B <- which(y.cgs == bounds[2])[1]
		A <- which(cgs == bounds[1])[1]
		if ((x.B - x.A) != (y.B - y.A)) {
			stop("sequences are non-adjacent (overlap CG mismatch)")
		}
		## UPDATE FRAGMENTATION PROFILE POSITIONS TO BE RELATIVE TO NEWLY COMBINED SEQUENCE INFORMATION
		if (x@start < y@start) {
#			num.preceding.fragments <- length(which(unlist(lapply(x@fragments.T, slot, "position")) < y@start))
			for (i in 1:length(y@fragments.T)) {
				y@fragments.T[[i]]$assay.name <- as.character(position(y))
				y@fragments.T[[i]]$position <- y@fragments.T[[i]]$position + y@start - x@start
				y@fragments.T[[i]]$ID <- as.integer(y@fragments.T[[i]]$ID + length(x@fragments.T))
				y@fragments.T[[i]]$collision.IDs <- relist(unlist(y@fragments.T[[i]]$collision.IDs) + length(x@fragments.T), y@fragments.T[[i]]$collision.IDs)
			}				
			for (i in 1:length(y@fragments.C)) {
				y@fragments.C[[i]]$assay.name <- as.character(position(y))
				y@fragments.C[[i]]$position <- y@fragments.C[[i]]$position + y@start - x@start
				y@fragments.C[[i]]$ID <- as.integer(y@fragments.C[[i]]$ID + length(x@fragments.C))
				y@fragments.C[[i]]$collision.IDs <- relist(unlist(y@fragments.C[[i]]$collision.IDs) + length(x@fragments.C), y@fragments.C[[i]]$collision.IDs)
			}
		}
		else {
			for (i in 1:length(x@fragments.T)) {
				x@fragments.T[[i]]$assay.name <- as.character(position(x))
				x@fragments.T[[i]]$position <- x@fragments.T[[i]]$position + x@start - y@start
			}				
			for (i in 1:length(x@fragments.C)) {
				x@fragments.C[[i]]$assay.name <- as.character(position(x))
				x@fragments.C[[i]]$position <- x@fragments.C[[i]]$position + x@start - y@start
			}
			for (i in 1:length(y@fragments.T)) {
				y@fragments.T[[i]]$assay.name <- as.character(position(y))
				y@fragments.T[[i]]$ID <- as.integer(y@fragments.T[[i]]$ID + length(x@fragments.T))
				y@fragments.T[[i]]$collision.IDs <- relist(unlist(y@fragments.T[[i]]$collision.IDs) + length(x@fragments.T), y@fragments.T[[i]]$collision.IDs)
			}				
			for (i in 1:length(y@fragments.C)) {
				y@fragments.C[[i]]$assay.name <- as.character(position(y))
				y@fragments.C[[i]]$ID <- as.integer(y@fragments.C[[i]]$ID + length(x@fragments.C))
				y@fragments.C[[i]]$collision.IDs <- relist(unlist(y@fragments.C[[i]]$collision.IDs) + length(x@fragments.C), y@fragments.C[[i]]$collision.IDs)
			}
		}
		x@fragments.T <- c(x@fragments.T, y@fragments.T)
		x@fragments.C <- c(x@fragments.C, y@fragments.C)
		if (overlap) {
			if (substr(x@sequence, bounds[1] - x@start + 1, bounds[2] - x@start + 1) != substr(y@sequence, bounds[1] - y@start + 1, bounds[2] - y@start + 1)) {
				stop("sequences are non-adjacent (overlap sequence mismatch)")
			}
			x@sequence <- paste(substr(x@sequence, 0, bounds[1] - x@start), 
					substr(y@sequence, 0, bounds[1]-y@start), 
					substr(x@sequence, bounds[1] - x@start + 1, bounds[2] - x@start + 1), 
					substr(x@sequence, bounds[2] - x@start + 2, nchar(x@sequence) + 1), 
					substr(y@sequence, bounds[2] - y@start + 2, nchar(y@sequence) + 1), 
					sep=""
				)
		}
		else {
			x@sequence <- paste(substr(x@sequence, 0, bounds[1] - x@start + 1), 
					substr(y@sequence, 0, bounds[1] - y@start + 1), 
					paste(rep(".", bounds[2] - bounds[1] - 1), collapse=""), 
					substr(x@sequence, bounds[2] - x@start + 1, nchar(x@sequence) + 1), 
					substr(y@sequence, bounds[2] - y@start + 1, nchar(y@sequence) + 1), 
					sep=""
				)
		}
		overlap <- x.B-x.A-1
		x.pre <- x.A-1
		y.pre <- y.A-1
		x.post <- length(x.cgs) - x.B
		y.post <- length(y.cgs) - y.B
		## COMBINE CpG METHYLATION DATA MATRICES
		N <- as.integer(x.pre + y.pre + overlap + x.post + y.post)
		CpG.data <- matrix(NA, nrow=length(c(x@samples, y@samples)), ncol=N, dimnames=list(c(samples(x), samples(y)), 1:N))
		if (length(x@samples) > 0) {
			CpG.data[1:length(x@samples), (A-x.A+1):(A-x.A+length(x.cgs)-2)] <- as.matrix(x@CpG.data)
		}
		if (length(y@samples) > 0) {
			CpG.data[1:length(y@samples)+length(x@samples), (A-y.A+1):(A-y.A+length(y.cgs)-2)] <- as.matrix(y@CpG.data)
		}
		## COMBINE SPECTRA
		x@samples <- c(x@samples, y@samples)
		x@groups <- c(x@groups, y@groups)
		samples.combined <- groups <- c()
		sample.names <- samples(x)
		sample.names.unique <- unique(sample.names)
		x@CpG.data <- CpG.data
		x@CpG.data.combined <- matrix(NA, nrow=length(sample.names.unique), ncol=N, dimnames=list(sample.names.unique, 1:N))
		for (i in 1:length(sample.names.unique)) {
			j <- which(sample.names == sample.names.unique[i])
			if (length(j) <= 1) {
				x@CpG.data.combined[i, ] <- CpG.data[j, ]
			}
			else {
				x@CpG.data.combined[i, ] <- apply(CpG.data[j, ], 2, mean, na.rm=TRUE)
			}
			if (length(unique(x@groups[j])) == 1) {
				groups <- c(groups, unique(x@groups[j]))
			}
			else {
				groups <- c(groups, x@groups[j][1])
				warning("multiple groups specified for a single sample, only the first will be used")
			}
			samples.combined <- c(samples.combined, list(sum.MassArraySpectrum(x@samples[j])))
		}
		x@CpG.data <- x@CpG.data.combined
		x@samples <- samples.combined
		x@groups <- as.character(groups)
		rownames(x@CpG.data.combined) <- sample.names.unique
		x@start <- min(x@start, y@start)
		x@end <- max(x@end, y@end)
		if (original == "-") {
			x <- revComplement(x)
		}
		
		return(x)
		
		
#		x@data <- matrix(NA, nrow=length(x@samples), ncol=x@N, dimnames=list(x@samples, 1:x@N))
#		conversion <- c(x@conversion, y@conversion)
#		x@conversion <- as.numeric(rep(NA, length(x@samples)))
#		for (i in 1:length(x@samples)) {
#			x@conversion[i] <- mean(conversion[j], na.rm=TRUE)
#			x@rxn[i] <- rxn[j][1]
#		}
	}
)

expandSequence <- function (sequence) {
	sequence <- toupper(gsub(" ", "", sequence))
	## SEQUENCE INPUT CAN CONTAIN BASE SHORT HAND (I.E. "A3T2G1" IS INTERPRETED AS "AAATTG")
	base.repeats <- gregexpr("[ATCG][0-9]+", sequence)
	sequence <- unlist(mapply(
		function (bases, sequence) {
			if (bases[1] < 0) return(sequence)
			sequence.old <- sequence
			for (base in bases) {
				sequence <- sub("[ATCG][0-9]+", paste(rep(substr(sequence.old, base, base), as.integer(substr(sequence.old, base + 1, base + attr(bases, "match.length")[which(base == bases)] - 1))), collapse=""), sequence)
			}	
			return(sequence)	
		},
		base.repeats,
		sequence
	))
	return(sequence)
}

calcMW <- function (sequence, extra=c("5OH", "5PPP-3P", "5PPP-3OH"), adduct=c("", "Na", "K"), rxn=c("T", "C")) {
	## ONLY DESIGNED TO CALCULATE MW FOR ONE SEQUENCE AT A TIME
	if (length(sequence) > 1) {
		warning("multiple sequence input (", length(sequence), " where 1 expected)")
		sequence <- sequence[1]
	}
	sequence <- expandSequence(sequence)
	extra <- match.arg(extra)
	adduct <- match.arg(adduct)
	rxn <- match.arg(rxn)
	## MOLECULAR WEIGHT MEASUREMENTS FOR EACH RNA BASE
	massA <- 329.2098
	massG <- 345.2091
	massC <- 289.1851
	## I DO NOT!!!!! UNDERSTAND THIS ADJUSTMENT, BUT DERIVED IT FROM THE SEQUENOM PREDICTED MASSES . . . EACH ADDITIONAL "T" IN SEQUENCE IS WEIGHTED WITH SLIGHTLY DIFFERENT MOLECULAR WEIGHT DEPENDING ON IF T OR C RXN
	switch(rxn,
		## NOTE: "T" IN RNA IS ACTUALLY A URACIL
		"T" = massT <- 306.169,
		"C" = massT <- 304.1967
	)

	molecularWeight <- function (sequence) {
		## NOTE: "R" INDICATES "A" OR "G"
		if (length(grep("R", sequence)) == 1) {
			return(unique(c(
				molecularWeight(sub("R", "A", sequence)), 
				molecularWeight(sub("R", "G", sequence))))
			)	
		}
		## NOTE: "Y" INDICATES "C" OR "T"
		if (length(grep("Y", sequence)) == 1) {
			return(unique(c(
				molecularWeight(sub("Y", "T", sequence)), 
				molecularWeight(sub("Y", "C", sequence))))
			)	
		}
		## NOTE: "N" INDICATES "A", "T", "C", OR "G"
		if (length(grep("N", sequence)) == 1) {
			return(unique(c(
				molecularWeight(sub("N", "A", sequence)), 
				molecularWeight(sub("N", "T", sequence)), 
				molecularWeight(sub("N", "C", sequence)), 
				molecularWeight(sub("N", "G", sequence))))
			)	
		}
		## ADJUSTMENT FOR INITIATING 5' PHOSPHATE AND 3' HYDROXYL GROUP
		switch(extra,
			"5OH" = MW <- 19.02327,
			"5PPP-3P" = MW <- 258.96227,
			"5PPP-3OH" = MW <- 178.9823
		)
		switch(adduct,
			"Na" = MW <- MW + 21.9818,
			"K" = MW <- MW + 38.0903
		)
		#### AGAIN, I DO NOT YET UNDERSTAND WHY!!!!!  BUT I KNOW THAT THIS CORRECTION IS NECESSARY IN ORDER TO GET C RXN TO AGREE WITH SEQUENOM!!!!
		switch(rxn,
			"T" = MW <- MW,
			"C" = MW <- MW + 15.9993
		)
		## ADD MOLECULAR WEIGHTS FOR EACH BASE IN SEQUENCE
		for (i in 1:nchar(sequence)) {
			base <- substr(sequence, i, i)
			switch(base,
				"A" = MW <- MW + massA,
				"G" = MW <- MW + massG,
				"C" = MW <- MW + massC,
				"T" = MW <- MW + massT,
				return(NA)
			)
		}
		return(round(MW, 3))
	}
	return(molecularWeight(sequence))
}

identifySNPs <- function (peak.sequence, sequence, rxn=c("T", "C")) {
	rxn <- match.arg(rxn)
	if (is.null(peak.sequence)) return()
	if (length(peak.sequence) < 1) return()
	if (nchar(peak.sequence) < 1) return()
	sequence <- gsub("[?]", "", toupper(sequence))
	## DEFINE ACCESSORY FUNCTIONS
	## BASE COMPOSITION WILL ANALYZE A SEQUENCE AND GENERATE INDIVIDUAL NUCLEOTIDE COUNTS
	baseComposition <- function(sequence) {
		if (length(grep("R", sequence)) == 1) {
			return(c(baseComposition(sub("R", "A", sequence)), baseComposition(sub("R", "G", sequence))))
		}
		if (length(grep("Y", sequence)) == 1) {
			return(c(baseComposition(sub("Y", "C", sequence)), baseComposition(sub("Y", "T", sequence))))
		}
		if (length(grep("N", sequence)) == 1) {
			return(c(baseComposition(sub("N", "A", sequence)), baseComposition(sub("N", "T", sequence)), baseComposition(sub("N", "C", sequence)), baseComposition(sub("N", "G", sequence))))
		}
		base.counts <- list("A" = 0,
			"T" = 0,
			"C" = 0,
			"G" = 0
		)
		for (base in names(base.counts)) {
			base.count <- gregexpr(base, sequence)[[1]]
			if (base.count[1] > 0) base.counts[base] <- length(base.count)
		}
		return(base.counts)	
	}
	## LOCAL FRAGMENTATION WILL EXTRACT ALL POSSIBLE LOCAL FRAGMENTS AROUND THE "?" CHARACTER
	localFragmentation <- function(sequence, ignore) {
		switch(rxn,
			"T" = fragment <- gregexpr(paste("[T][^T]*[?][^T]*[T]|^[^T]*[?][^T]*[T]|[T][^T]*[?][^T]*$", sep=""), sequence)[[1]],
			"C" = fragment <- gregexpr(paste("[C][^C]*[?][^C]*[C]|^[^C]*[?][^C]*[C]|[C][^C]*[?][^C]*$", sep=""), sequence)[[1]]
		)
		if (fragment[1] < 0) return(FALSE)
		if (length(fragment) != 1) return(FALSE)
		sequence.sub <- substr(sequence, fragment, fragment + attr(fragment, "match.length") - 1)
		if (length(grep("R", sequence.sub)) == 1) {
			if (is.character(base <- localFragmentation(sub("R", "A", sequence.sub), ignore))) return(base)
			if (is.character(base <- localFragmentation(sub("R", "G", sequence.sub), ignore))) return(base)
		}
		if (length(grep("Y", sequence.sub)) == 1) {
			if (is.character(base <- localFragmentation(sub("Y", "C", sequence.sub), ignore))) return(base)
			if (is.character(base <- localFragmentation(sub("Y", "T", sequence.sub), ignore))) return(base)
		}
		if (length(grep("N", sequence.sub)) == 1) {
			if (is.character(base <- localFragmentation(sub("N", "A", sequence.sub), ignore))) return(base)
			if (is.character(base <- localFragmentation(sub("N", "T", sequence.sub), ignore))) return(base)
			if (is.character(base <- localFragmentation(sub("N", "C", sequence.sub), ignore))) return(base)
			if (is.character(base <- localFragmentation(sub("N", "G", sequence.sub), ignore))) return(base)
		}
		for (base in setdiff(c("A", "T", "C", "G", ""), ignore)) {
			sequence.base.sub <- sub("[?]", base, sequence.sub)
			switch(rxn,
				"T" = sub.fragments <- gregexpr("[ACGNXYR.]*T", sequence.base.sub)[[1]],
				"C" = sub.fragments <- gregexpr("[ATGNXYR.]*C", sequence.base.sub)[[1]]
			)
			sub.fragments <- substr(rep(sequence.base.sub, length(sub.fragments)), 
				sub.fragments, 
				as.integer(sub.fragments) + attr(sub.fragments, "match.length") - 1
			)
			sub.fragments <- lapply(sub.fragments, baseComposition)
			SNP.matched <- any(unlist(lapply(sub.fragments, identical, base.counts)))
			if (SNP.matched) return(as.character(base))
		}
		return(FALSE)
	}
	peak.sequence <- expandSequence(peak.sequence)
	## DETERMINE BASE COUNTS FOR PEAK SEQUENCE
	base.counts <- baseComposition(peak.sequence)
	
	N <- nchar(sequence)
	SNPs <- c()
	for (i in 1:N) {
		sequence.i <- paste(substr(sequence, 0, i - 1), "?", substr(sequence, i + 1, N), sep="")
		if (is.character(base <- localFragmentation(sequence.i, substr(sequence, i, i)))) {
			if (base == "") {
				SNPs <- c(SNPs, list(list(sequence=peak.sequence, position=i, base=base, type="deletion")))
			}
			else {
				SNPs <- c(SNPs, list(list(sequence=peak.sequence, position=i, base=base, type="substitution")))
			}
		}
	}
	return(SNPs)
}

\name{convControl}
\alias{convControl}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Conversion control }
\description{
  Function to identify all potential conversion controls in a given input sequence, for a given list of fragments
}
\usage{
convControl(sequence, fragmentation, multiple = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input as a character string }
  \item{fragmentation}{ List of MassArrayFragment objects corresponding to the fragmentation pattern of the sequence input }
  \item{multiple}{ Logical value specifying whether or not to include multiple CGs on the same conversion control fragment where possible (default is \code{FALSE}). }
}
\details{
 Potential conversion controls are identified from the nucleotide sequence input through pattern recognition of fragments that contain non-CG cytosines.
 Any conversion controls that contain CG dinucleotides or have a molecular weight outside of the usable mass window are screened out. 
  Additionally, conversion controls that are located in identified primer sequence or have molecular weight overlap with other fragments are removed from consideration. 
  Lastly, if the consideration of the fragment as a conversion control will cause new molecular weight overlap(s) with one or more other fragments, the control is also removed from consideration.
}
\value{
  Returns a list of MassArrayFragment objects identical to the input, with the exception that conversion controls are labeled and updated accordingly.
}
\author{  Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
MassArray.example.data$fragments.T[[54]]
conversion.data <- convControl(MassArray.example.data$sequence, MassArray.example.data$fragments.T)
conversion.data[[54]]
}
\seealso{ See Also as \code{\linkS4class{MassArrayFragment}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }
\keyword{ character }

\name{sum.MassArraySpectrum}
\alias{sum.MassArraySpectrum}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Sum MassArraySpectrum objects }
\description{
  Function to collapse multiple MassArraySpectrum objects into a single MassArraySpectrum representing the sum of each
}
\usage{
\method{sum}{MassArraySpectrum}(x, ..., trim = 0, na.rm = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ One or multiple MassArraySpectrum objects to include in sum }
  \item{\dots}{ Any additional MassArraySpectrum objects to include in sum }
  \item{trim}{ Numerical value between 0 and 0.5 specifying the proportion of spectra to remove from consideration on a per peak basis, such that the SNR of each peak is calculated as the trimmed mean of the same peak across all included spectra. }
  \item{na.rm}{ Logical value passed to \code{mean}, indicating whether \code{NA} values should be stripped before the computation proceeds.  }
}
\value{
  Returns a single \code{MassArraySpectrum} object that represents the union of all unique peaks from the component MassArraySpectrum objects, with SNR for each peak representing the average value of that peak across all spectra
}
\author{  Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
MassArray.example.data$samples[[1]]$peaks[[11]]$height
MassArray.example.data$samples[[1]] <- sum.MassArraySpectrum(MassArray.example.data$samples[[1]], MassArray.example.data$samples[[2]])
MassArray.example.data$samples[[1]]$peaks[[11]]$height
}
\seealso{ See Also as \code{\linkS4class{MassArraySpectrum}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

\name{MassArray.example.data}
\Rdversion{1.1}
\alias{MassArray.example.data}
\docType{data}
\title{
MassArray Data object
}
\description{
This data contains MassArray spectral information for two samples.
}
\usage{MassArray.example.data}
\format{
  The format is:
Formal class 'MassArrayData' [package "MassArray"] with 17 slots
  ..@ sequence         : chr "CCAGGTCCAAAGGTTCAGACCAGTCTGAACCTGTCCAGGGGCACTCCATATTTTCCTACCTGTCCCTCTTTGCTTGTAAAAACAAATTAAACAGGGATCCCAGCAACTTCGGGGCATGTGTGTAACT"| __truncated__
  ..@ chr              : chr(0) 
  ..@ start            : int(0) 
  ..@ end              : int(0) 
  ..@ strand           : chr "+"
  ..@ fwd.tag          : chr "AGGAAGAGAG"
  ..@ rev.tag          : chr "AGCCTTCTCCC"
  ..@ fwd.primer       : num 29
  ..@ rev.primer       : num 27
  ..@ lower.threshold  : num 1500
  ..@ upper.threshold  : num 9000
  ..@ fragments.T      :List of 89
  .. ..$ :Formal class 'MassArrayFragment' [package "MassArray"] with 21 slots
  .. .. .. ..@ ID                 : int 1
  .. .. .. ..@ assay.name         : chr ""
  .. .. .. ..@ name               : chr ""
  .. .. .. ..@ sequence           : chr "GGGAGAAGGCT"
  .. .. .. ..@ position           : int 385
  .. .. .. ..@ length             : int 11
  .. .. .. ..@ CpGs               : int 0
  .. .. .. ..@ MW                 : num 3913
  .. .. .. ..@ collisions         : int 0
  .. .. .. ..@ collision.IDs      :List of 1
  .. .. .. .. ..$ : int(0) 
  .. .. .. ..@ CG.collisions      : int 0
  .. .. .. ..@ CG.collision.IDs   : list()
  .. .. .. ..@ type               : chr "T"
  .. .. .. ..@ direction          : chr "+"
  .. .. .. ..@ extra              : chr "5PPP-3P"
  .. .. .. ..@ bisulfite.converted: logi TRUE
  .. .. .. ..@ assayable          : logi TRUE
  .. .. .. ..@ conversion.control : logi FALSE
  .. .. .. ..@ required           : logi FALSE
  .. .. .. ..@ ignored            : logi FALSE
  .. .. .. ..@ primer             : logi TRUE
  ..@ samples          :List of 2
  .. ..$ :Formal class 'MassArraySpectrum' [package "MassArray"] with 9 slots
  .. .. .. ..@ sample             : chr "A"
  .. .. .. ..@ rxn                : chr "T"
  .. .. .. ..@ strand             : chr "+"
  .. .. .. ..@ peaks              :List of 184
  .. .. .. .. ..$ :Formal class 'MassArrayPeak' [package "MassArray"] with 16 slots
  .. .. .. .. .. .. ..@ ID              : int 1
  .. .. .. .. .. .. ..@ MW.theoretical  : num 1111
  .. .. .. .. .. .. ..@ MW.actual       : num NA
  .. .. .. .. .. .. ..@ probability     : num 0
  .. .. .. .. .. .. ..@ SNR             : num 0
  .. .. .. .. .. .. ..@ height          : num NA
  .. .. .. .. .. .. ..@ sample.intensity: num NA
  .. .. .. .. .. .. ..@ ref.intensity   : num 0.1
  .. .. .. .. .. .. ..@ sequence        : chr "ACACAAT"
  .. .. .. .. .. .. ..@ adduct          : chr ""
  .. .. .. .. .. .. ..@ type            : chr "Modified"
  .. .. .. .. .. .. ..@ charge          : int 1
  .. .. .. .. .. .. ..@ collisions      : int 0
  .. .. .. .. .. .. ..@ components      : int 0
  .. .. .. .. .. .. ..@ missing         : logi TRUE
  .. .. .. .. .. .. ..@ new             : logi FALSE
  .. .. .. ..@ quality.conversion : num [1:4] 0.0529 0 0 0
  .. .. .. ..@ quality.spectra    : num NA
  .. .. .. ..@ quality.primerdimer: num [1:7] 8.51 15.83 3.28 1.04 0 ...
  .. .. .. ..@ quality.contaminant: num NA
  .. .. .. ..@ quality.adducts    : num [1:114] 1 1 0.97 0.231 0.412 ...
  ..@ groups           : chr(0) 
  ..@ CpG.data         : num [1:2, 1:18] 0.0322 0.0449 0.1468 0.3641 0.1468 ...
  ..@ CpG.data.combined: num [1:2, 1:18] 0.0322 0.0449 0.1468 0.3641 0.1468 ...
}
\source{
Thompson et al. 2009
}
\examples{
data(MassArray.example.data)
}
\keyword{datasets}

\name{position}
\alias{position}
%- Also NEED an '\alias' for EACH other topic documented here.
\alias{position<-}
\title{ Operate on positional information }
\description{
  Function to access (and/or assign) positional information for a MassArrayData object
}
\usage{
position(object)
position(object) <- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{ Object of class \code{MassArrayData}}
  \item{value}{ Character string containing positional information of the form "chrXX:XXXX-XXXX" }
}
\value{
  Returns a character string containing positional information of the form "chrXX:XXXX-XXXX" if accessing a \code{MassArrayData} object. If updating a \code{MassArrayData} object, function returns the object with updated positional information
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
position(MassArray.example.data)
position(MassArray.example.data) <- "chrB:2001-2374"
position(MassArray.example.data)
}
\seealso{ See Also \code{\linkS4class{MassArrayData}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ attribute }

\name{samples}
\alias{samples}
%- Also NEED an '\alias' for EACH other topic documented here.
\alias{samples<-}
\title{ Operate on sample name(s) }
\description{
  Function to access (and/or assign) sample name information for a MassArrayData object
}
\usage{
samples(object)
samples(object) <- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{ Object of class \code{MassArrayData}}
  \item{value}{ List of character strings containing sample name information, one for each sample contained in the \code{MassArrayData} object }
}
\value{
  Returns a list of character strings containing sample name information for each sample in \code{MassArrayData} object. If updating a \code{MassArrayData} object, function returns the object with updated sample name information
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
samples(MassArray.example.data)
samples(MassArray.example.data)[2] <- "SECOND"
samples(MassArray.example.data)
}
\seealso{ See Also as \code{\linkS4class{MassArrayData}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ attribute }

\name{MassArrayData-class}
\docType{class}
\alias{MassArrayData-class}
\alias{$,MassArrayData-method}
\alias{$<-,MassArrayData-method}
\alias{[,MassArrayData-method}
\alias{initialize,MassArrayData-method}

\title{Class "MassArrayData" }
\description{A data structure containing MassArray data and associated information for a single amplicon}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MassArrayData", sequence, file, verbose, fwd.tag, rev.tag, fwd.primer, rev.primer, strand, lower.threshold, upper.threshold, header, skip, sep, comment.char, fill, method, position, ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{sequence}:}{Nucleotide sequence for unconverted amplicon}
    \item{\code{chr}:}{Chromosomal position of amplicon}
    \item{\code{start}:}{Chromosomal position of amplicon}
    \item{\code{end}:}{Chromosomal position of amplicon}
    \item{\code{strand}:}{DNA strand used for amplicon (can be '+' or '-')}
    \item{\code{fwd.tag}:}{Nucleotide tag sequence 5' of the forward primer}
    \item{\code{rev.tag}:}{T7-containing nucleotide tag sequence 5' of the reverse primer}
    \item{\code{fwd.primer}:}{Length (in bp) of forward primer}
    \item{\code{rev.primer}:}{Length (in bp) of reverse primer}
    \item{\code{lower.threshold}:}{Lower limit (in Da) of usable mass window (default: \option{1500})}
    \item{\code{upper.threshold}:}{Upper limit (in Da) of usable mass window (default: \option{7000})}
    \item{\code{fragments.T}:}{List containing objects of class \code{MassArrayFragment}, corresponding to the T-cleavage reaction for the amplicon on the specified \code{strand}}
    \item{\code{fragments.C}:}{List containing objects of class \code{MassArrayFragment}, corresponding to the C-cleavage reaction for the amplicon on the specified \code{strand}}
    \item{\code{samples}:}{List containing object of class \code{MassArraySpectrum}, each corresponding to spectral data from a single sample}
    \item{\code{groups}:}{List of the group name to which each sample belongs}
    \item{\code{CpG.data}:}{Matrix containing analyzed methylation data, where each row is a sample and each column is a CG dinucleotide site}
    \item{\code{CpG.data.combined}:}{Matrix containing methylation data combined from multiple objects (or collapsed from within a single object), where each row is a sample and each column is a CG dinucleotide site}
  }
}
\section{Methods}{
  \describe{
    \item{\$}{\code{signature(x = "MassArrayData")}: ... }
    \item{\$<-}{\code{signature(x = "MassArrayData")}: ... }
    \item{[}{\code{signature(x = "MassArrayData")}: ... }
    \item{initialize}{\code{signature(.Object = "MassArrayData")}: ... }
	 }
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
showClass("MassArrayData")
}
\keyword{classes}

\name{plot.MassArrayData}
\alias{plot.MassArrayData}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Plot MassArrayData }
\description{
  Function to generate graphical output for methylation data in a \code{MassArrayData} object
}
\usage{
\method{plot}{MassArrayData}(x, ..., collapse = TRUE, bars = TRUE, scale = TRUE, sequence = TRUE, labels = TRUE, colors = TRUE, main = position(x), width = 1.5)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ Object of class \code{MassArrayData} }
  \item{\dots}{ Other arguments to plot, currently not supported at this time }
  \item{collapse}{ Logical specifying whether or not to combine samples by unique \code{group} (see \code{\linkS4class{MassArrayData}}). If \code{TRUE}, each methylation values are averaged across all samples in each unique group. If \code{FALSE}, all samples are retained and plotted individually }
  \item{bars}{ Logical specifying whether or not to display error bars. If \code{TRUE} (and \code{collapse} is \code{TRUE}), the median absolute deviation is calculated for each group and plotted as an error bar for each methylation value. If \code{FALSE}, no error bars are displayed}
  \item{scale}{ Logical specifying whether or not to keep the x axis to scale.  If \code{TRUE}, methylation values are plotted as a function of relative position within the amplicon sequence. If \code{FALSE}, positional information is ignored and methylation values are evenly spaced across the plot window.}
  \item{sequence}{ Logical specifying whether or not to display the nucleotide sequence for the amplicon }
  \item{labels}{ Logical specifying whether or not to display data labels }
  \item{colors}{ Logical specifying whether or not to plot in color.  If \code{TRUE}, colors are used.  If \code{FALSE}, plotting occurs in black and white and grayscale. }
  \item{main}{ Label/title for overall plot (default is \code{""} }
  \item{width}{ Numerical value specifying the display width to use for each methylation value; number corresponds to the number of base pairs to include in both directions from the methylation position (default is \code{1.5})}
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
plot(MassArray.example.data,collapse=FALSE,bars=FALSE,scale=FALSE)
}
\seealso{ See Also \code{\linkS4class{MassArrayData}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ aplot }

\name{evaluateSNPs}
\alias{evaluateSNPs}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Evaluate SNPs }
\description{
  Function to analyze a MassArrayData object for all potential single nucleotide polymorphisms (SNPs) indicated by new and/or missing peaks in the the spectral data for one or more samples
}
\usage{
evaluateSNPs(x, verbose = TRUE, plot = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ MassArrayData object containing spectral data for one or more samples }
  \item{verbose}{ Logical specifying whether or not to display descriptive progress updates as SNPs are analyzed }
  \item{plot}{ Logical specifying whether or not to display graphical representation of fragmentation profiles (default is \code{TRUE})}
}
\details{
  This function performs an exhaustive search for all potential SNPs (single base pair substitutions or deletions) that may give rise to new and/or missing peaks.  Graphical output is displayed 
  by default, and extensive data describing putative SNPs is also returned.
  
  Note that the graphical output does not contain a built-in legend at this time, but the plot may be interepreted as follows: 
  In the uppermost panel the T-cleavage fragmentation profile is shown for a given amplicon (C-cleavage reactions occupy a split screen whenever relevant). CG dinucleotides (filled circles) are numbered and colored in blue. Other fragments are colored 
  according to their ability to be assayed:  fragment molecular weight outside the testable mass window (gray), fragment molecular weight overlapping with another fragment (red), fragment 
  containing a potential conversion control (green), or fragment uniquely assayable but containing no CGs (black). Putative SNPs are shown directly below their location within the amplicon 
  fragmentation profile. Each row represents analysis from a single sample. Small, gray symbols represent potential SNPs that do not have sufficient evidence (presence of a new peak with 
  corresponding absence of an expected peak). Larger black symbols indicate a potential SNP with both new peaks and missing expected peaks. Triangles indicate base pair substitution, while 
  circles indicate single base pair deletion.
}
\value{
	Returns a list of potential SNPs for each identified new peak in the spectral data.  Note that each new peak may be explained by any number of potential SNPs; the list returned only includes the most reliable hits, but the redundant nature of the data necessitates returning a nested list, such that each new peak is associated with the following list elements:
  \item{SNP}{Contains a list of SNPs, each of which takes the form "\code{position}:\code{base}" where \code{position} is the base pair location within the amplicon sequence, and \code{base} is the mutated character}
  \item{SNR}{Contains a numerical list of signal-to-noise ratios corresponding to the expected original peak for the fragment mapping to the identified SNP position}
  \item{fragment}{Contains a numerical list of fragment IDs which map the SNP position to a specific fragment}
  \item{SNP.quality}{Contains a numerical list (values ranging from \code{0} to \code{2}, with \code{0} being a highly unlikely SNP and \code{2} being a SNP with increased likelihood.  This number is calculated as a function of new peak SNR and expected peak SNR.}
  \item{samples}{Contains a list of samples whose spectral data contained the given new peak}
  \item{count}{Specifies the number of unique SNP and sample pairs, exactly equivalent to the length of \code{SNP}, \code{SNR}, \code{fragment}, \code{SNP.quality}, or \code{samples}}
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
SNP.data <- evaluateSNPs(MassArray.example.data[2,])
}
\seealso{ See Also \code{\link{identifySNPs}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ attribute }
\keyword{ manip }

\name{samples-methods}
\docType{methods}
\alias{samples-methods}
\alias{samples,MassArrayData-method}
\alias{samples<-,MassArrayData,missing-method}
\alias{samples<-,MassArrayData,character-method}
\title{ Operate on sample name(s) (methods)}
\description{
 Methods to access (and/or assign) sample name information for a MassArrayData object
}
\section{Methods}{
\describe{

\item{object = "MassArrayData"}{ Access sample name information for MassArrayData object }

\item{object = "MassArrayData", value = "missing"}{ Handle empty function call, simply return the MassArrayData object }

\item{object = "MassArrayData", value = "character"}{ Assign sample name of MassArrayData object to \code{value} }
}}
\seealso{ \code{\link{samples}} }
\keyword{methods}

\name{createWiggle}
\alias{createWiggle}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Create wiggle track }
\description{
 Function to create and write a wiggle track (UCSC Genome Browser format) to flat file from methylation data contained in a MassArrayData object
}
\usage{
createWiggle(x, file = "", append = FALSE, colors = NULL, na.rm = FALSE, sep = " ")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ \code{MassArrayData} object containing methylation data for at least one sample. }
  \item{file}{ location of file to write wiggle track information; if \option{""}, wiggle track prints to the standard output connection: see \code{\link{cat}}. }
  \item{append}{ logical; if \option{TRUE}, the output is appended to an existent wiggle track file. If \option{FALSE} (default), a new file with a new header is created and any existing file of the same name is destroyed. }
  \item{colors}{ vector of colors, indicates which colors to use for which wiggle track }
  \item{na.rm}{ logical; if \option{TRUE} (default), missing values are removed from data. If \option{FALSE} any missing values cause an error }
  \item{sep}{ a string used to separate columns. Using \option{sep = "\t"} (default) gives tab-delimited output. }
}
\references{ UCSC Genome Browser, \url{http://genome.ucsc.edu/goldenPath/help/customTrack.html}:
Kent, W.J., Sugnet, C. W., Furey, T. S., Roskin, K.M., Pringle, T. H., Zahler, A. M., and Haussler, D. The Human Genome Browser at UCSC. \emph{Genome Res}. \bold{12}(6), 996-1006 (2002). }
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
createWiggle(MassArray.example.data)
}
\seealso{ \code{\link{write}}, \code{\link{cat}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ print }

\name{identifySNPs}
\alias{identifySNPs}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Identify SNPs }
\description{
  Function to identify potential single nucleotide polymorphisms (SNPs) which allow mapping of a novel peak sequence to the expected amplicon sequence
}
\usage{
identifySNPs(peak.sequence, sequence, rxn = c("T", "C"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{peak.sequence}{ Nucleotide sequence (can also be base composition - ex: "A6G2C1T3") as a character string }
  \item{sequence}{ Nucleotide sequence for wildtype/expected amplicon as a character string }
  \item{rxn}{ One of "T" or "C" specifying which cleavage reaction to use for SNP analysis }
}
\details{
  The algorithm steps through the \code{sequence}, substituting one nucleotide at a time with the other three base pairs or a blank character (deletion), in order to determine a base compositional match to the input \code{peak.sequence} which represents a peak not found in the native \code{sequence}.
}
\value{
  Returns a list of potential SNP matches for the input \code{peak.sequence}. Each element of the list contains multiple items as follows:
  \item{sequence}{ corresponds to \code{peak.sequence}}
  \item{position}{ corresponds to the matched position within \code{sequence}}
  \item{base}{ corresponds to the altered nucleotide (i.e. "A", "T", "C", "G", or "")}
  \item{type}{ corresponds to the class of SNP (i.e. "substitution" or "deletion")}
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
## SINGLE SUBSTITUTION
identifySNPs("AAGT","AATTTT")
## MULTIPLE SUBSTITUTION POSSIBILITIES
identifySNPs("A1G1T1","AATTTT")
## DELETION
identifySNPs("AAT","AGATTTT")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }
\keyword{ manip }

\name{combine}
\alias{combine}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Combine MassArrayData objects }
\description{
  Function to join two MassArrayData objects by sequence positions and samples
}
\usage{
combine(x, y, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ MassArrayData object }
  \item{y}{ MassArrayData object }
  \item{\dots}{ Other arguments passed to combine not supported at this time.  }
}
\value{
  Returns a single MassArrayData object that contains a union of samples and amplicons and spectral data from both MassArrayData objects in input
}
\author{  Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
samples(MassArray.example.data)
combined.data <- combine(MassArray.example.data[2,], MassArray.example.data[1,])
samples(combined.data)
}
\seealso{ See Also \code{\linkS4class{MassArrayData}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

\name{MassArraySpectrum-class}
\docType{class}
\alias{MassArraySpectrum-class}
\alias{$,MassArraySpectrum-method}
\alias{$<-,MassArraySpectrum-method}
\alias{initialize,MassArraySpectrum-method}

\title{Class "MassArraySpectrum" }
\description{A data structure containing MassArray spectral data for a single sample}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MassArraySpectrum", sample, rxn, strand, peaks, quality.conversion, quality.spectra, quality.primerdimer, quality.contaminant, quality.adducts, ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{sample}:}{Sample name}
    \item{\code{rxn}:}{Cleavage reaction (either 'T' or 'C')}
    \item{\code{strand}:}{DNA strand for amplicon (either '+' or '-')}
    \item{\code{peaks}:}{List containing objects of class \code{MassArrayPeak}}
    \item{\code{quality.conversion}:}{Overall level(s) of remnant unconverted cytosines, as measured by one or more conversion controls}
    \item{\code{quality.spectra}:}{(currently not supported)}
    \item{\code{quality.primerdimer}:}{(currently not supported)}
    \item{\code{quality.contaminant}:}{(currently not supported)}
    \item{\code{quality.adducts}:}{Overall ratio(s) of Na and/or K adduct peak heights to expected peak heights}
  }
}
\section{Methods}{
  \describe{
    \item{\$}{\code{signature(x = "MassArraySpectrum")}: ... }
    \item{\$<-}{\code{signature(x = "MassArraySpectrum")}: ... }
    \item{initialize}{\code{signature(.Object = "MassArraySpectrum")}: ... }
	 }
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\seealso{
	See Also \code{\linkS4class{MassArrayData}}
}
\examples{
showClass("MassArraySpectrum")
}
\keyword{classes}

\name{calcMeth}
\alias{calcMeth}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate percent methylation }
\description{
  Function to calculate percent methylation from a collection of peaks corresponding to a single fragment.
}
\usage{
calcMeth(SNR.list, fragments = rep(1, length(SNR.list)), non.cg.fragments = numeric(0), method = c("weighted", "proportion"), prune.non.cg.peaks = TRUE, na.rm = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{SNR.list}{ List of signal-to-noise ratios, sorted from low to high MWs, corresponding to the unmethylated and methylated peaks for a given set of fragments }
  \item{fragments}{ List of all fragments contributing to each of the input peaks, automatically defaulting to a single fragment }
  \item{non.cg.fragments}{ List of fragments (without CGs) contributing to any of the input peaks, automatically defaulting to \code{numeric(0)} }
  \item{method}{ Specifies which algorithm to use when calculating percent methylation (either \code{"weighted"} or \code{"proportion"}) }
  \item{prune.non.cg.peaks}{ Boolean value determining whether or not to remove non-CG-containing fragments prior to analysis or whether to include them in the calculating model (note that setting this option to \code{FALSE} could result in a considerable increase in analytical time); option automatically defaults to \code{TRUE} }
  \item{na.rm}{ Boolean value determing whether or not to return an error on input of any unspecified data (\code{NA}), automatically defaulting to \code{FALSE} } 
}
\details{
  Note that the current release of this function performs as expected for the large majority of cases.  However, certain complex combinations of peak overlaps are not handled at this time.  
  This may affect data for a minority of points, particularly those containing multiple overlaps with alternative fragments.  Please ensure more in-depth review of such loci.
}
\value{
  Returns a numerical values corresponding to percent methylation, with 0% indicating no methylation and 100% indicating complete methylation.
}
\references{   Coolen, M.W., et al. (2007) Genomic profiling of CpG methylation and allelic specificity using quantitative high-throughput mass spectrometry: critical evaluation and improvements, \emph{Nucleic Acids Research}, \strong{35}(18), e119. }
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
frags <- MassArray.example.data$fragments.T[[6]]$"MW"
peaks <- findPeaks(frags, unlist(lapply(MassArray.example.data$samples[[1]]$peaks, slot, "MW.actual")))
SNRs <- unlist(lapply(MassArray.example.data$samples[[1]]$peaks[peaks], slot, "SNR"))
frag.list <- list(1:3, 1:3, 1:3, 1:3)
calcMeth(SNRs, fragments=frag.list, method="weighted")
calcMeth(SNRs, fragments=frag.list, method="proportion")
}
\seealso{ See Also \code{\linkS4class{MassArrayPeak}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ arith}
\keyword{ manip }

\name{bisConvert}
\alias{bisConvert}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Bisulphite conversion }
\description{
 Bisulphite convert nucleotide sequence input
}
\usage{
bisConvert(sequence)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence in the form of a character string }
}
\value{
  Returns a character value corresponding to the bisulphite converted input sequence.
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
bisConvert("AAATTCGGAACCC")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }

\name{revComplement}
\alias{revComplement}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Reverse complement }
\description{
  Function to find the reverse complement
}
\usage{
revComplement(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ sequence input to use for reverse complement. \code{x} can be a character string or a MassArrayData object. }
}
\value{
  Returns the reverse complement of a character string or MassArrayData object, depending upon input data type.
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\seealso{ \code{\link{revComplement-methods}} }
\examples{
revComplement("AATCCGGGGGAA")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }

\name{isAssayable}
\alias{isAssayable}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Is assayable? }
\description{
  Function to determine whether or not a given molecular weight is assayable (i.e. within the usable mass window specified)
}
\usage{
isAssayable(MW, lower.threshold = 1500, upper.threshold = 7000)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{MW}{ Numerical input corresponding to molecular weight }
  \item{lower.threshold}{Lower limit (in Da) of usable mass window (default: \option{1500})}
  \item{upper.threshold}{Upper limit (in Da) of usable mass window (default: \option{7000})}
}
\value{
  Returns a logical corresponding to whether or not the molecular weight input falls within the usable mass window specified
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
isAssayable(5000)
isAssayable(1200)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ logic }

\name{importEpiTyperData}
\alias{importEpiTyperData}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Import EpiTyper data (v.1.0) }
\description{
  Function to read and import an EpiTyper datafile (v.1.0) and store it as a MassArraySpectrum objects
}
\usage{
importEpiTyperData(data, MassArrayObject, verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{ location of EpiTyper datafile as a character string }
  \item{MassArrayObject}{ Pre-existent MassArrayData object in which store relevant sample and spectral information from datafile }
  \item{verbose}{ Logical specifying whether or not to display descriptive progress updates as datafile is processed }
}
\details{
  EpiTyper v.1.0 datafiles must only contain a single amplicon, thus the user must export peak data for one amplicon at a time.
}
\value{
  Returns a list of MassArraySpectrum objects each populated by spectral data
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\seealso{ See Also \code{\linkS4class{MassArraySpectrum}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ attribute }
\keyword{ file }

\name{calcMW}
\alias{calcMW}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate molecular weight }
\description{
  Function to calculate molecular weight of a fragment generated by the MassCLEAVE assay for either the T or C cleavage reactions
}
\usage{
calcMW(sequence, extra = c("5OH", "5PPP-3P", "5PPP-3OH"), adduct = c("", "Na", "K"), rxn = c("T", "C"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input }
  \item{extra}{ One of "5OH" (default), "5PPP-3P", or "5PPP-3OH" describing 5' and/or 3' modifications of the fragment}
  \item{adduct}{ One of 'Na', 'K', or '' (default) specifying whether or not the molecular weight should be calculated for a salt adduct }
  \item{rxn}{ One of 'T' or 'C' indicating which cleavage reaction is employed to generate the fragment }
}
\value{
  Returns a numerical output corresponding to the molecular weight (in Da) of sequence input. Note that the output may actually represent multiple molecular weights 
  if/whenever the input sequence contains one or more degenerate bases (e.g. R or Y).
}
\author{  Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu})  }
\examples{
calcMW("AAATCCC")
calcMW("AARTYCC")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }
\keyword{ arith }

\name{findPeaks}
\alias{findPeaks}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Find peaks }
\description{
  Function to determine which peak(s) in a list of peaks match a given molecular weight.
}
\usage{
findPeaks(MW, peaks, resolution = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{MW}{ Molecular weight target (in Da) }
  \item{peaks}{ List of molecular weights corresponding to unique peaks }
  \item{resolution}{ Resolution (in Da), used to specify the ability to distinguish two different molecular weights. For a resolution of \option{1} (default), two molecular weights are considered identical if they are less than \option{1} Da apart.}
}
\value{
  Returns the index or indices of peak(s) within the input list that have a molecular weight which matches that specified as input 
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
findPeaks(3.1, 6:1, res=0)
findPeaks(3.1, 6:1, res=0.2)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ list }
\keyword{ manip }

\name{rnaDigest}
\alias{rnaDigest}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ RNA digest }
\description{
  Function to perform an in silico RNAse A digest for either the T or C cleavage reactions
}
\usage{
rnaDigest(sequence, type = c("T", "C"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input }
  \item{type}{ One of either 'T' or 'C', specifying which cleavage reaction mixture was used }
}
\value{
  Returns a list of \code{MassArrayFragment} objects, each containing information about a given fragment generated by the RNA digest
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
rnaDigest("AAAACCCCCTGCGGAGAGAGGCCGACAAAA", type="T")
}
\seealso{ See Also as \code{\linkS4class{MassArrayFragment}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }
\keyword{ manip }

\name{ampliconPrediction}
\alias{ampliconPrediction}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Amplicon prediction }
\description{
  Function to predict amplicon fragmentation pattern and details for T&C reactions on the plus and minus strands
}
\usage{
ampliconPrediction(sequence, lower.threshold = 1500, upper.threshold = 7000, fwd.tag = "AGGAAGAGAG", rev.tag = "AGCCTTCTCCC", plot = TRUE, table = TRUE, lwd = 1, cex = 1, multiple.conversion = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input as a character string }
  \item{lower.threshold}{Lower limit (in Da) of usable mass window (default: \option{1500})}
  \item{upper.threshold}{Upper limit (in Da) of usable mass window (default: \option{7000})}
  \item{fwd.tag}{Nucleotide tag sequence 5' of the forward primer}
  \item{rev.tag}{T7-containing nucleotide tag sequence 5' of the reverse primer}
  \item{plot}{ Logical specifying whether or not to display graphical representation of fragmentation profiles (default is \code{TRUE})}
  \item{table}{ Logical specifying whether or not to return tabular representation of fragmentation profiles (default is \code{TRUE}) }
  \item{lwd}{The line width used for fragmentation display, a positive number, defaulting to \code{1}}
  \item{cex}{A numerical value (defaulting to \code{1}) giving the amount by which plotting text and symbols should be magnified relative to the default}
  \item{multiple.conversion}{Logical value specifying whether or not to include multiple CGs on the same conversion control fragment where possible (default is \code{FALSE}).}
}
\details{
  Plotted fragmentation patterns contain a number of detailed features including: CG positions, molecular weight overlaps, conversion controls, fragment assayability, and more.

  Note that the graphical output does not contain a built-in legend at this time, but the plot may be interepreted as follows: 
  Putative fragmentation patterns are shown for T and C-cleavage reactions on both the plus and minus strands of an input amplicon, with the T-forward, T-reverse, C-forward, and C-reverse 
  shown in descending order. CG dinucleotides (filled circles) are numbered and colored in blue. Other fragments are colored according to their ability to be assayed:  fragment molecular 
  weight outside the testable mass window (gray), fragment molecular weight overlapping with another fragment (red), fragment containing a potential conversion control (green), or 
  fragment uniquely assayable but containing no CGs (black). Linked arrowheads denote molecular weight overlaps between multiple CG-containing fragments. Yellow highlights represent 
  tagged or primer sequences, while lavender highlights denote user-specified "required" sites.
}
\value{
  If \code{table} is \code{TRUE}, returns a list containing the following items:
  \item{summary }{A summary matrix of logical values specifying whether or not each CG is assayable by a given combination of cleavage reaction and DNA strand}
  \item{counts}{A numerical tally of the quantity of CGs that are assayable by each assay}
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu})  }
\examples{
ampliconPrediction("TGGAACACCCAGCAAAGATCAAGCAGGAAAGGGCGCACGCAGCCTTCGTTGCTAACCTCCTCTGGACTCTGGTACCCCAGGCACCGCGAATGCTCCCCACCTCAGCCCCCTGACCTTTACCATCGCTGAAGCGGGCGTCGCTGATGTCTGCGGCGAGCCTGCCGACCAGCCCAGCTGCCCAGAGGAGCAGCCAGGCAAGGGCGCTGGCAGCCAGGACGCCGGAGCCCGACGCCCGAGAGGGGCGCGCGGAGCAAGCTGCGGTCACGGGAGGAACCTGAGCACGCAGAGCGTACCCCCACCTTCCACGGTGACCCGGACAGAACGCTCCTTGCGCTCCCACCCTAGGACCCCCTGTAACTCCAGGTTCCTGAGA")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ graphs }
\keyword{attribute }
\keyword{ character }
\keyword{ aplot }

\name{expandSequence}
\alias{expandSequence}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Expand nucleotide sequence }
\description{
  Function to process shorthand form of a nucleotide sequence, where a given base pair followed by a number specifies a run of the indicated nucleotide for the specified length (ex: "A6TTCGA4")
}
\usage{
expandSequence(sequence)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input as a character string }
}
\value{
  Returns an expanded nucleotide sequence as a character string
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
expandSequence("A6TTCGA4")
expandSequence("C10C10")
expandSequence("AT1CG")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }
\keyword{ manip }

\name{calcPercentConversion}
\alias{calcPercentConversion}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate percent conversion }
\description{
  Function to calculate percent methylation (wrapper for \code{calcMeth()} function) for each identified conversion control
}
\usage{
calcPercentConversion(fragments, peaks)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fragments}{ List of MassArrayFragment objects }
  \item{peaks}{ List of MassArrayPeak objects comprising spectral data to be used for conversion control calculations }
}
\details{
  This function serves as a wrapper function for \code{calcMeth()}, such that percent methylation is calculated for all conversion controls within the input list of fragments.
}
\value{
  Returns a list of numerical values (from 0 to 1) corresponding to percent methylation for each conversion control, with 0% indicating complete conversion and 1 (100%) indicating a complete failure of bisulphite conversion. 
  Note that each element within the returned list will represent conversion control(s) for a single sample, while each element may contain multiple values with each value corresponding to data obtained from a single conversion control fragment.
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
conversion.data <- calcPercentConversion(MassArray.example.data$fragments.T, MassArray.example.data$samples[[1]]$peaks)
mean(conversion.data)

# NOTE: conversion control data may already be contained within a MassArrayData object; these data can be accessed and visualized by the following (or alternative) commands
conversion.data <- unlist(lapply(lapply(MassArray.example.data$samples, slot, "quality.conversion"), median, na.rm=TRUE))
barplot(conversion.data)
}
\seealso{ See Also \code{\link{calcMeth}}, \code{\link{convControl}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ attribute }
\keyword{ arith }

\name{estimatePrimerDimer}
\alias{estimatePrimerDimer}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Estimate Primer Dimers }
\description{
  Function to estimate level of signal due to primer dimers in a given spectrum
}
\usage{
estimatePrimerDimer(fragments, peaks, method = c("ratio", "mann-whitney"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fragments}{ List of MassArrayFragment objects corresponding to the sample }
  \item{peaks}{ List of MassArrayPeak objects comprising spectral data for a complete assay }
  \item{method}{ Specifies which algorithm to use when estimating primer dimer levels (either \code{"ratio"} or \code{"mann-whitney"}) }
}
\details{
  Primer dimers are calculated by: 1) identifying fragments that occur within the expected primer sequence, 2) identifying which of these fragments is assayable, and 3) comparing the overall signal for primer peaks and peaks from the rest of the amplicon.
}
\value{
  Returns a list containing primer dimer ratios or significance estimates (i.e. p-values) depending on the analytical method specified (\code{"ratio"} or \code{"mann-whitney"}, respectively).  Returns \code{"NA"} in cases where insufficient data is present to calculate primer dimer levels.
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
primer.data <- estimatePrimerDimer(MassArray.example.data$fragments.T, MassArray.example.data$samples[[1]]$peaks, "ratio")
mean(primer.data)
primer.data <- estimatePrimerDimer(MassArray.example.data$fragments.T, MassArray.example.data$samples[[1]]$peaks, "mann-whitney")
mean(primer.data)
}
\seealso{ See Also \code{\linkS4class{MassArrayData}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

\name{combine-methods}
\docType{methods}
\alias{combine-methods}
\alias{combine,MassArrayData,MassArrayData-method}
\alias{combine,MassArrayData,missing-method}
\title{ Combine MassArrayData objects (methods)}
\description{
Methods for joining two MassArrayData objects by sequence positions and samples, or simply operating on a single MassArrayData object to combine samples, depending on input
}
\section{Methods}{
\describe{

\item{x = "MassArrayData", y = "MassArrayData"}{ Combine two MassArrayData objects by position and then by sample }

\item{x = "MassArrayData", y = "missing"}{ Combine duplicate samples within the same MassArrayData object }
}}
\seealso{ See Also \code{\link{combine}} }
\keyword{methods}
\keyword{ manip}

\name{countCGs}
\alias{countCGs}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Count number of CGs}
\description{
  Function to count the number of CG dinucleotides in a given sequence (can include special characters for degenerate bases - i.e. 'Y' or 'R')
}
\usage{
countCGs(sequence)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input as a character string }
}
\value{
  Returns a numerical count of the number of CG dinucleotides in a given sequence, \option{NA} if sequence input is \option{NA}
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
countCGs("AAACGCGAAAAAAAYGAAA")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ character }

\name{MassArrayPeak-class}
\docType{class}
\alias{MassArrayPeak-class}
\alias{$,MassArrayPeak-method}
\alias{$<-,MassArrayPeak-method}
\alias{initialize,MassArrayPeak-method}

\title{Class "MassArrayPeak" }
\description{A data structure containing information and data for a single peak from a single spectrum}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MassArrayPeak", ID, MW.theoretical, MW.actual, probability, SNR, height, sample.intensity, ref.intensity, sequence, adduct, type, charge, collisions, components, missing, new, ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{ID}:}{Peak ID inicating indexed position within a potentially large list of peaks}
    \item{\code{MW.theoretical}:}{Expected molecular weight of peak based on nucleotide sequence}
    \item{\code{MW.actual}:}{Observed molecular weight from experimental data}
    \item{\code{probability}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{SNR}:}{Signal-to-noise ratio}
    \item{\code{height}:}{Raw peak height}
    \item{\code{sample.intensity}:}{Raw sample intensity}
    \item{\code{ref.intensity}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{sequence}:}{Nucleotide composition or sequence(s) corresponding to peak}
    \item{\code{adduct}:}{One of 'Na', 'K', or '' indicating whether or not peak represents a salt adduct of another expected peak}
    \item{\code{type}:}{Object of class \code{"character"} ~~ }
    \item{\code{charge}:}{Degree of ionization of fragment (default is '1' indicating a single positive charge per fragment)}
    \item{\code{collisions}:}{Number of peaks that share the same molecular weight as the current peak}
    \item{\code{components}:}{Number of fragments expected to give rise to a peak of this molecular weight }
    \item{\code{missing}:}{Logical indicating whether or not the expected peak is missing from the spectral data }
    \item{\code{new}:}{Logical indicating whether or not the observed peak is unexpected given the amplicon sequence}
  }
}
\section{Methods}{
  \describe{
    \item{\$}{\code{signature(x = "MassArrayPeak")}: ... }
    \item{\$<-}{\code{signature(x = "MassArrayPeak")}: ... }
    \item{initialize}{\code{signature(.Object = "MassArrayPeak")}: ... }
	 }
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\seealso{
	See Also \code{\linkS4class{MassArrayData}}
}
\examples{
showClass("MassArrayPeak")
}
\keyword{classes}

\name{inSilicoFragmentation}
\alias{inSilicoFragmentation}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ In silico fragmentation }
\description{
 Function to perform a complete in silico fragmentation of input sequence. Provides wrapper to a number of different functions, each of which determines additional information about each fragment.
}
\usage{
inSilicoFragmentation(sequence, fwd.tag = "", rev.tag = "", type = c("T", "C"), lower.threshold = 1500, upper.threshold = 7000, fwd.primer = 0, rev.primer = 0, multiple.conversion = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sequence}{ Nucleotide sequence input as a character string }
  \item{fwd.tag}{Nucleotide tag sequence 5' of the forward primer}
  \item{rev.tag}{T7-containing nucleotide tag sequence 5' of the reverse primer}
  \item{type}{ One of 'T' or 'C' indicating which cleavage reaction to use }
  \item{lower.threshold}{Lower limit (in Da) of usable mass window (default: \option{1500})}
  \item{upper.threshold}{Upper limit (in Da) of usable mass window (default: \option{7000})}
  \item{fwd.primer}{Length (in bp) of forward primer}
  \item{rev.primer}{Length (in bp) of reverse primer}
  \item{multiple.conversion}{Logical value specifying whether or not to include multiple CGs on the same conversion control fragment where possible (default is \code{FALSE}).}
}
\details{
  In silico fragmentation analysis includes RNAse A digestion, peak mapping and overlap detection, CG detection, assayability and conversion controls.
}
\value{
  Returns a list of \code{MassArrayFragment} objects, each with extensive contextual and other information
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
inSilicoFragmentation("GGGTTAGTCC")
}
\seealso{ See Also as \code{\linkS4class{MassArrayFragment}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{manip }
\keyword{character }
\keyword{ attribute }

\name{MassArrayFragment-class}
\docType{class}
\alias{MassArrayFragment-class}
\alias{$,MassArrayFragment-method}
\alias{$<-,MassArrayFragment-method}
\alias{initialize,MassArrayFragment-method}

\title{Class "MassArrayFragment" }
\description{A data structure containing information for a single fragment of an amplicon}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MassArrayFragment", ID, sequence, assay.name, name, position, type, direction, extra, bisulfite.converted, assayable, primer, ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{ID}:}{Unique integer indexing the fragment's position within a potential list of multiple fragments}
    \item{\code{assay.name}:}{(currently not supported)}
    \item{\code{name}:}{(currently not supported)}
    \item{\code{sequence}:}{Bisulphite converted nucleotide sequence of fragment}
    \item{\code{position}:}{Relative position of fragment within the amplicon}
    \item{\code{length}:}{Length (in bp) of fragment sequence}
    \item{\code{CpGs}:}{Number of CG dinucleotides contained within the fragment}
    \item{\code{MW}:}{Predicted molecular weight(s) of fragment, including methylated and unmethylated mass, adducts, etc.}
    \item{\code{collisions}:}{Number of fragments that share the same molecular weight as the current fragment}
    \item{\code{collision.IDs}:}{IDs of other fragments that share the same molecular weight as the current fragment}
    \item{\code{CG.collisions}:}{Number of CG-containing fragments that share the same molecular weight as the current fragment}
    \item{\code{CG.collision.IDs}:}{IDs of other CG-containing fragments that share the same molecular weight as the current fragment}
    \item{\code{type}:}{Specifies either 'T' or 'C' cleavage reaction}
    \item{\code{direction}:}{DNA strand used for fragment sequence (can be '+' or '-')}
    \item{\code{extra}:}{One of "5PPP-3P", "5OH", or "5PPP-3OH" (default)}
    \item{\code{bisulfite.converted}:}{Logical indicating whether the fragment sequence represents bisulfite converted sequence}
    \item{\code{assayable}:}{Logical indicating whether or not the fragment molecular weight is within the usable mass window}
    \item{\code{conversion.control}:}{Logical indicating whether or not the fragment is designated as a potential conversion control}
    \item{\code{required}:}{Logical indicating whether or not the fragment is designated as 'required' by the user}
    \item{\code{ignored}:}{Logical indicating whether or not the fragment is to be ignored}
    \item{\code{primer}:}{Logical indicating whether or not the fragment overlaps with primer or tagged sequence}
  }
}
\section{Methods}{
  \describe{
    \item{\$}{\code{signature(x = "MassArrayFragment")}: ... }
    \item{\$<-}{\code{signature(x = "MassArrayFragment")}: ... }
    \item{initialize}{\code{signature(.Object = "MassArrayFragment")}: ... }
	 }
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\seealso{
See Also \code{\linkS4class{MassArrayData}}
}
\examples{
showClass("MassArrayFragment")
}
\keyword{classes}

\name{revComplement-methods}
\docType{methods}
\alias{revComplement-methods}
\alias{revComplement,MassArrayData-method}
\alias{revComplement,character-method}
\title{ Reverse complement (methods)}
\description{
 Methods for reverse complement
}
\section{Methods}{
\describe{

\item{x = "MassArrayData"}{ Finds reverse complement of a MassArrayData object, a function that consists of altering sequence, strand, fragmentation, and methylation data }

\item{x = "character"}{ Calculates reverse complement from nucleotide sequence as character input }
}}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\seealso{ \code{\link{revComplement}} }
\keyword{methods}

\name{findCollisions}
\alias{findCollisions}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Find peak collisions }
\description{
  Function to determine which subset(s) of peaks collide with eachother (i.e. molecular weights are indistinguishable given the specified resolution) 
}
\usage{
findCollisions(peaks, resolution = 0.5)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{peaks}{ Numerical list of molecular weights (in Da) corresponding to a set of peaks }
  \item{resolution}{ Resolution (in Da), used to specify the ability to distinguish two different molecular weights. For a resolution of \option{0.5} (default), two molecular weights are considered identical if they are less than \option{0.5} Da apart.}
}
\value{
  Returns a list of peak collisions for each peak in the original list, thus the data object returned is in the form of a nested list.
}
\author{ Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
findCollisions(1:5, 1.5)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ list }
\keyword{ manip }

\name{calcPercentAdduct}
\alias{calcPercentAdduct}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate percent salt adducts }
\description{
  Function to calculate ratio of salt adduct peak heights to reference/unmodified peaks
}
\usage{
calcPercentAdduct(peaks)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{peaks}{ List of MassArrayPeak objects comprising complete spectral data }
}
\details{
  Salt adducts (either Na or K) are identified and compared to each of their unmodified reference peaks
}
\value{
  Returns a list of numerical values corresponding to the ratios of salt adduct peak heights to their unmodified reference peaks
}
\author{  Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
adduct.ratios <- calcPercentAdduct(MassArray.example.data$samples[[1]]$peaks)
median(adduct.ratios)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ arith }
\keyword{ attribute }

\name{analyzeCpGs}
\alias{analyzeCpGs}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Analyze CG methylation }
\description{
  Function to determine percent methylation for all CGs from input fragmentation
}
\usage{
analyzeCpGs(fragments, peaks, method = c("weighted", "proportion"))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fragments}{ List of MassArrayFragment objects }
  \item{peaks}{ List of MassArrayPeak objects comprising spectral data for a given assay}
  \item{method}{ Specifies which algorithm to use when calculating percent methylation (either "weighted" or "proportion") }
}
\details{
  Wrapper function for \code{calcMeth()}, takes fragmentation pattern and spectral data as input and applies percent methylation calculation for all CG-containing, non conversion control fragments
}
\value{
  Returns a list of numerical values corresponding to percent methylation for each CG dinucleotide, with 0% indicating no methylation and 100% indicating complete methylation.
}
\author{  Reid F. Thompson (\email{rthompso@aecom.yu.edu}), John M. Greally (\email{jgreally@aecom.yu.edu}) }
\examples{
data(MassArray.example.data)
cpg.data <- analyzeCpGs(MassArray.example.data$fragments.T, MassArray.example.data$samples[[1]]$peaks, method="weighted")
barplot(cpg.data, xlab="CpG (Number)", ylim=c(0,1), ylab="Methylation (Percent)")
}
\seealso{ See Also \code{\link{calcMeth}} }
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ attribute }
\keyword{ arith }
